/* gcc -o m mergeSort.c -lm */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void mergesort(unsigned int n, int *input, int *scratch)
{
  if(n<=1)
    return;
  {
    unsigned int i = 0;
    unsigned int mid = n/2;
    int* left  = input;
    int* right = &input[mid];
    int* endr  = &input[n];
    int* endl  = right;
    /* Sort sub arrays */
    mergesort(mid, left, scratch);
    mergesort(n-mid, right, scratch);
    /* Merge sorted sub arrays */
    for(i=0; i<n; i++){
      if(left < endl && (*left<*right || right>=endr))
        scratch[i] = *left++;
      else
        scratch[i] = *right++;
    }
    for(i=0; i<n; i++)
      input[i] = scratch[i];
  }
}

void mergesort_opt(unsigned int n, int *x, int *s)
{ /* not working */
  if(n<=1)
    return;
  {
    unsigned int i = 0;
    unsigned int mid = n/2;
    int* left  = s;
    int* right = &s[mid];
    int* endr  = &s[n];
    int* endl  = right;
    /* Sort sub arrays */
    mergesort_opt(mid, x, left);
    mergesort_opt(n-mid, &x[mid], right);
    if(x[mid-1] <= x[mid])return;    /* no need to merge */
    /* Merge sorted sub arrays */
    while(1){
      if(left >= endl || right>=endr)
        break;
      if(*left < *right)
        *x++ = *left++;
      else
        *x++ = *right++;
    }
    /* Copy tails */
    if(left<endl)
      memcpy(x,left,sizeof(int)*(endl-left));
    else
      memcpy(x,right,sizeof(int)*(endr-right));
  }
}

/* Example of how to call the sort algorithm */
#define N 9
int main(void)
{
  int i;
  int x[N] = {-7, 6, 5, 6, 8, 4, 4, -12, 0}; /* Input vector */
  int s[N]; /* Scratch space */

  /* Display input */
  for(i=0;i<N;i++) {
    s[i]=x[i];
    printf("%d ",x[i]);
  }
  printf("\n");

  /* Call sort algorithm */
  mergesort_opt(N, x, s);
//  mergesort(N, x, s);

  /* Display result */
  for(i=0;i<N;i++)
    printf("%d ",x[i]);
  printf("\n");

  return 0;
}

