Module aovconst
!
!!AovConst.f90 : global definitions for Aov.f90
      Implicit None
!
! parameters fixed at compile time
!
      Character (Len=*), Parameter :: VER = '25.04.2020' !! version
      Integer, Parameter :: SP = Kind (1e0)!! type of measurements and errors
      Integer, Parameter :: CP = Kind ((1._SP, 1._SP))!! type of complex values
      Integer, Parameter :: TIME = Kind (1d0)!! type of time & frequency variables
      Integer, Parameter :: LSTRING = 40 !! max input string length
!
      Real(SP), Parameter :: PI2 = 6.283185307179586476925286766559005768394_SP
!
      Type SPEC_T !! Spectrum structure
         Integer :: nfr !! number of frequencies
         Real (TIME) :: fr0 !! lowest frequency
         Real (TIME) :: frs !! frequency increment
         Real (SP), Allocatable :: th (:)!! frequency spectrum/periodogram
      End Type SPEC_T
      Type OBS_T !! Observations structure
         Integer :: no = 0 !! number of observations
         Logical :: weights = .False. !! Weights present?
         Real (TIME) :: epoch = 0._TIME !! Epoch
         Real (TIME) :: tmin = 0._TIME !! Min time
         Real (TIME) :: tmax = 0._TIME !! Max time
         Real (TIME), Allocatable :: t (:)
         Real (SP), Allocatable :: v (:), w (:)
      End Type OBS_T
      Character (Len=80) :: msg !! a string variable of local use
      Integer :: io !! a status variable of local use
End Module aovconst
