var tipuesearch = {"pages":[{"title":" Aov ","text":"Aov The c and f95 versions of the package are located in the corresponding \nsubdirectories. See Program tab on the top of this page for an expanded description. author: Alex Schwarzenberg-Czerny author_description: I am astronomer at Nicolaus Copernicus Astronomical Centre, Warsaw, Poland. One of my interests is in applications of statistics in astronomy and analysis of uneven sampled time series. github: https://github.com/cmacmackin\nemail: alex@camk.edu.pl\nfpp_extensions: fpp\npredocmark: >\nmedia_dir: ./media\ndocmark_alt: #\npredocmark_alt: <\ndisplay: public\n         protected\n         private\nsource: false\ngraph: true\nsearch: true\nmacro: TEST\n       LOGIC=.true.\nextra_mods: json_module: http://jacobwilliams.github.io/json-fortran/\n            futility: http://cmacmackin.github.io\nlicense: by-nc\nextra_filetypes: sh #","tags":"home","loc":"index.html"},{"title":"aovper.f90 – Aov","text":"Contents Modules aovper Source Code aovper.f90 Source Code Module aovper !!  Purpose: <br> !!  State-of-art routines for period search in unevenly sampled time series. !!  Package contains routines for phase folding and binning, Fourier series fit !!  power spectrum and search of planetary transits, for weighted and unweighted !!  observations. !! !!  Calling:<br> !!  Demo calling example is contained in `AovDrv` routine in this file. !!  Because of numerical considerations times of observations need to be shifted !!  by subtraction of `EPOCH` time so that they span 0. This is not done within !!  ` aovper`routines to enable the user use of one value of EPOCH for !!  independent runs.<br> !!  All routines  come in two flavours: for !!  weighted and unweighted observations. Their calling sequences are uniform, !!  though depending on routine some parameters are ignored.<br> !!  CHAR sptype - determines type of frequency spectrum returned from routine; !!        for `RAW`, `AOV`, `MODEL`, `RESID` the spectrum obeys: !!        none, F, beta and another beta probability distributions<br> !!  INT no - number of observations<br> !!  TIMES t(No) - times of observations<br> !!  FLOAT v(no) - values of observations<br> !!  FLOAT w(no) - weights of observations <br> !!  INT npar - input number of parameters of mathematical model in use;<br> !!  INT ncov - input number of different phase origins employed to smooth !!       effects of time discretization<br> !!  SPEC_T spec - on input contains spectrum array `th(no)` and parameters of its !!  frequency grid `nfr`, `fr0`, `frs`,  where `freq=ifr*frs+fr0, ifr=0,...,nfr-1`; !!       on output `th` contains resultant frequency spectrum.<br> !! !!  Methods:<br> !!  The Aov package contains routines for period search and !!  planetary transit search by phase folding and binning of light curves !!  and/or by multi-harmonic Fourier series fit. For a particular set up !!  these routines reproduce popular box-least squares and generalised Lomb !!  Scargle algorithm, ableit in a more efficient implementations involving sub bins !!  or orthogonal projections. <br> !! !!  The period routines split into two groups: !!  (i) `AOV/TR & AOVMH` calculate quadratic norm of a fitted model. !!  As such their results obey Parceval theorem. Depending on `SPTYPE` parameter !!  the result spectrum may be converted to classical statistics: either aov !!  (Fisher F) spectrum or the corresponding beta statistics spectra of normalized !!  'model power' or 'residual chi2' flavour.<br> !!  (i.A) `AOV/TR`: Depending on sign of npar: for npar>0 `aov/tr` routine fits !!  folded light curve with a histogram of npar bins, for `npar<0` `aov/tr` routine !!  fits light curve with just two phase bins: in- and out-of suspect transit. !!  The transit width is fixed by npar while its position is fine-tuned !!  depending on `ncov`. (Reference: A.Schwarzenberg-Czerny, 1989, MNRAS 241, 153; !!  A.Schwarzenberg-Czerny, & J.-Ph. Beaulieu,  2006, MNRAS 365, 165.<br> !!  (i.B) `AOVMH` fits Fourier series of npar terms by orthogonal projection on !!  Szego polynomials. Reference: A.Schwarzenberg-Czerny, 1996, ApJ 460L, 107. !!  In particular for `npar=3` `AOVMH` returns Generalised !!  Lomb-Scargle spectrum of Ferraz-Mello, 1981 and Zechmeister & Kurster, 2009.<br> !!  (ii) The other two routines, `PWSP` & `PWSPW`, return squared amplitude of a fitted !!  sinusoid. The underlying algorithms differ from each other even for unary !!  weights. For uneven sampling the result power spectra obey no Parceval theorem !!  hence power spectra obey no classical probability distribution. Provided all !!  input values are 1 `PWSP` returns window function (`PWSPW` does not).<br> !!  Several general utility routines are provided:<br> !!  `GRID`, `PEAK` and `PEAKRM` to set up frequency spectrum and analyse its peaks. !!  `NORM_TIMES` from module `AovObs` may be used to subtract `EPOCH` from times. <br> !! Copyrights: <br> !!  This package is subject to copyrights by its author, !!  (C) A. Schwarzenberg-Czerny 1998-2018, alex@camk.edu.pl !!  Its distribution is free, except that distribution of modifications is !!  prohibited. Please acknowlege use by citation of papers listed in the !!  corresponding routines. Use aovconst Use mprms , Only : EPOCH , ERRIN , VERBOSE , CTMIN Use aovsub Use aovobs ! Implicit None !subroutine spectrum(sptype, no, npar, vf, spec) !function aovmh(sptype,t,vin,w,npar,ncov,spec) !function aovmhw(sptype,t,vin,win,npar,ncov,spec) !function aov(sptype,t,vin,w,np,ncov,spec) !function aovw(sptype,t,vin,win,np,ncov,spec) !function powsp(sptype, t,vin,w, npar, ncov, spec) !function powspw(sptype,t,vin,win,npar,ncov,spec) !function aovdrv(method,sptype,t,v,w,npar,ncov,spec) ! Private !public aovdrv,spectrum,,aovmh,aovmhw,aov,aovw,powsp,powspw Public aovdrv ! Contains ! Subroutine spectrum ( sptype , no , npar , vf , spec ) !! Purpose: <br> !! Converts quadratic norm of fitted model into !! one of frequency spectrum classic Fisher statistics Integer , Intent ( In ) :: no !! number of observations Integer , Intent ( In ) :: npar !! number of model parameters Character ( Len =* ), Intent ( In ) :: sptype !! type of returned spectrum Real ( SP ), Intent ( In ) :: vf !! sum of squares Type ( SPEC_T ) :: spec !! frequency and spectrum grid ! Real ( SP ) :: fac Select Case ( trim ( sptype )) ! SP_RAW,SP_AOV,SP_MODEL,SP_RESID Case ( 'RAW' ) ! do nothing Continue Case ( 'AOV' ) ! convert to F(npar,no-npar;th) fac = ( no - npar ) / ( npar - 1._SP ) spec % th = spec % th / Max ( vf - spec % th , TINY ( vf )) * fac Case ( 'MODEL' ) ! convert to ibeta(npar/2,(no-npar)/2;th) spec % th = spec % th / vf Case ( 'RESID' ) ! convert to ibeta((no-npar)/2,npar/2;th) spec % th = 1._SP - spec % th / vf Case Default If ( VERBOSE ) Print * , \"Spectrum: wrong SPTYPE\" End Select ! End Subroutine spectrum ! ! ========================================================================== ! AOVMH & AOVMHW routines for multiharmonic Fourier spectrum ! Function aovmh ( sptype , t , vin , w , npar , ncov , spec ) !! Routine for LSQ fit of Fourier harmonics via projection on orthogonal !! polynomialsfor. No weighting of observations ! !!Purpose: !!Respectively for no weights and weights present AOVMH & AOVMHW  fit !!unevenlysampled time series with a multiharmonic Fourier series and !!return spectrum for a range of Fourier frequencies. On input NPAR !!sets number of Fourier terrms (NPAR/2 harmonics). For NPAR=3 and !!SPTYPE=SP_MODEL, AOVMH & AOVMHW results are identical to !!Ferraz-Mello(1981) and Zechmeister & Kurster (2009) generalized !!Lomb-Scargle (GLS) spectrum. NCOV is ignored. !! !!Method: !!By Szego recurrence AOVMH & AOVMHW generate orthogonal trigonometric !!polynomials and next by orthogonal projection expand uneven sampled time !!series in terms of these polynomials. Such an algorithm constitutes the !!fastest implementation of Fourier series least squares fit. For NPAR>>3 !!these algorithms are particularly suitable to detect smooth non-sinusoidal !!oscillations involving sharp features (e.g. eclipses and narrow pulses). !!For detection of sine signals in statistical sense (sensitivity) AOVMH & !!AOVMHW never perform worse than either Lomb-Scargle or Power Spectrum. !!For non-sinusoidal signals AOVMH & AOVMHW advantage becomes significant. !!For identical NPAR, AOVMH & AOVMHW are about 10 times slower than more crude !!AOV/AOVW routines. ! !!Copyrights and Distribution: !!This routines are subject to copyrights by its author, !!(C) A. Schwarzenberg-Czerny 1998-2005,  alex@camk.edu.pl !!Its distribution is free, except that distribution of modifications !!is prohibited. !!Please quote A.Schwarzenberg-Czerny, 1996, Astrophys. J.,460, L107 !!while using AOVMH & AOVMHW. Integer :: aovmh !! status Real ( TIME ), Intent ( In ) :: t (:) !! times of observations Real ( SP ), Intent ( In ) :: vin (:) !! values of observations Real ( SP ), Intent ( In ) :: w (:) !! dummy Integer , Intent ( In ) :: npar !! number of parameters (2*nh+1) Integer , Intent ( In ) :: ncov !! dummy Character ( Len =* ), Intent ( In ) :: sptype !! type of returned spectrum Type ( SPEC_T ) :: spec !! frequency grid and result spectrum ! Integer :: l , n , nn2 , nh , no Real ( TIME ) :: ph ( size ( t )) Real ( SP ) :: sn , sav , v ( size ( t )) Complex ( CP ), Dimension ( size ( t )) :: cf , p , z , zn Complex ( CP ) :: al , sc ! aovmh = ncov + size ( w ) ! dummy use aovmh = 1 no = size ( t ) nh = Max ( 1 , npar / 2 ) nn2 = nh + nh ! ! normalize observations sav = sum ( vin ) / no v = vin - sav sav = sum ( v ** 2 ) If ( no . Lt . nn2 + 2 ) Then If ( VERBOSE ) Print * , 'AOVMH:error: too few observations' Return End If ! spec % th = 0. Do l = 1 , spec % nfr ph = ( spec % frs * ( l - 1 ) + spec % fr0 ) * t ! ph = PI2 * ( ph - floor ( ph )) z = cmplx ( Cos ( ph ), Sin ( ph ), kind = CP ) ph = ph * nh cf = v * cmplx ( Cos ( ph ), Sin ( ph ), kind = CP ) zn = 1._SP p = 1. ! Do n = 0 , nn2 sn = sum ( Abs ( p ) ** 2 ) al = sum ( z * p ) ! NOTE: dot_product(a,b)=sum(conjg(a)*b) sc = dot_product ( p , cf ) ! !      sn = Max (sn, 10._SP*tiny(sn)) sn = Max ( sn , epsilon ( sn )) al = al / sn spec % th ( l ) = spec % th ( l ) + Abs ( sc ) ** 2 / sn p = p * z - al * zn * conjg ( p ) zn = zn * z End Do End Do Call spectrum ( sptype , no , nn2 + 1 , sav , spec ) aovmh = 0 End Function aovmh ! Function aovmhw ( sptype , t , vin , win , npar , ncov , spec ) !! Routine for LSQ fit of Fourier harmonics via projection on orthogonal !! polynomialsfor. Weights are applied to observations. ! !!Purpose:<br> !!Respectively for no weights and weights present AOVMH & AOVMHW  fit !!unevenlysampled time series with a multiharmonic Fourier series and !!return spectrum for a range of Fourier frequencies. On input NPAR !!sets number of Fourier terrms (NPAR/2 harmonics). For NPAR=3 and !!SPTYPE=SP_MODEL, AOVMH & AOVMHW results are identical to !!Ferraz-Mello(1981) and Zechmeister & Kurster (2009) generalized !!Lomb-Scargle (GLS) spectrum. NCOV is ignored. !! !!Method: <br> !!By Szego recurrence AOVMH & AOVMHW generate orthogonal trigonometric !!polynomials and next by orthogonal projection expand uneven sampled time !!series in terms of these polynomials. Such an algorithm constitutes the !!fastest implementation of Fourier series least squares fit. For NPAR>>3 !!these algorithms are particularly suitable to detect smooth non-sinusoidal !!oscillations involving sharp features (e.g. eclipses and narrow pulses). !!For detection of sine signals in statistical sense (sensitivity) AOVMH & !!AOVMHW never perform worse than either Lomb-Scargle or Power Spectrum. !!For non-sinusoidal signals AOVMH & AOVMHW advantage becomes significant. !!For identical NPAR, AOVMH & AOVMHW are about 10 times slower than more crude !!AOV/AOVW routines. ! !!Copyrights and Distribution:<br> !!This routines are subject to copyrights by its author, !!(C) A. Schwarzenberg-Czerny 1998-2005,  alex@camk.edu.pl !!Its distribution is free, except that distribution of modifications !!is prohibited. !!Please quote A.Schwarzenberg-Czerny, 1996, Astrophys. J.,460, L107 !!while using AOVMH & AOVMHW. Integer :: aovmhw !! status Real ( TIME ), Intent ( In ) :: t (:) !! times of observations Real ( SP ), Intent ( In ) :: vin (:) !! values of observations Real ( SP ), Intent ( In ) :: win (:) !! weights of observations Integer , Intent ( In ) :: npar !! number of parameters (2*nh+1) Integer , Intent ( In ) :: ncov !! dummy Character ( Len =* ), Intent ( In ) :: sptype !! type of returned spectrum Type ( SPEC_T ) :: spec !! frequency grid and result spectrum ! Integer :: l , n , nn2 , nh , no ! Real ( SP ) :: sn , sav , rw ( size ( t )), vr ( size ( t )) Real ( TIME ) :: ph ( size ( t )) Complex ( CP ), Dimension ( size ( t )) :: cf , p , z , zn Complex ( CP ) :: al , sc ! aovmhw = ncov ! dummy use aovmhw = 1 nh = Max ( 1 , npar / 2 ) nn2 = nh + nh ! ! normalize observations rw = 0._SP Where ( win > 0._SP ) rw = Sqrt ( win ) no = count ( rw > 0._SP ) vr = vin * rw sav = sum ( vr * rw ) / sum ( rw ** 2 ) vr = vr - sav * rw sav = sum ( vr ** 2 ) If ( no . Lt . nn2 + 2 ) Then If ( VERBOSE ) Print * , 'AOVMHW:error: too few observations' Return End If spec % th = 0. Do l = 1 , spec % nfr ph = ( spec % frs * ( l - 1 ) + spec % fr0 ) * t ! !   (f,g)=sum(w*conjg(f)*g) -definition ph = PI2 * ( ph - floor ( ph )) z = cmplx ( Cos ( ph ), Sin ( ph ), kind = CP ) ph = ph * nh cf = vr * cmplx ( Cos ( ph ), Sin ( ph ), kind = CP ) zn = 1._SP p = rw ! Do n = 0 , nn2 sn = sum ( Abs ( p ) ** 2 ) al = sum ( rw * z * p ) ! NOTE: dot_product(a,b)=sum(conjg(a)*b) sc = dot_product ( p , cf ) ! sn = Max ( sn , epsilon ( sn )) al = al / sn spec % th ( l ) = spec % th ( l ) + Abs ( sc ) ** 2 / sn p = p * z - al * zn * conjg ( p ) zn = zn * z End Do End Do Call spectrum ( sptype , no , nn2 + 1 , sav , spec ) aovmhw = 0 End Function aovmhw !  End of AOVMH & AOVMHW routines for multiharmonic Fourier spectrum ! ========================================================================== ! Function aov ( sptype , t , vin , w , np , ncov , spec ) !! Routine for phase folding and binning of observations using no weights<br> ! !! Purpose:<br> !! The state-of-art routines for either period search by phase folding and !! binning of observations (for NP>0) or for search for periodic transits/pulses !! of short duty cycle, with constat signal elsewhere (for NP<0). In the latter !! case data are fitted with just two unequal phase bins: in- and out-of transit. ! !! Method:<br> !! In any case observations are phase folded and binned into NP equal phase !! bins starting at NCOV sub-bin phases. Subsequently the algorithm !! either sums squares of bin averages (for NP>0). For transit search !! (NP<0) algorithm searches for the maximum value phase bin (considered !! in-transit for magnitude units). Its squared value and identities stemming !! from Parceval theorem are employed to evaluate sum of squares for two !! phase-bins in- and out-of transit. Note: here transits are defined as MAXIMA !! (i.e. in magnitude units). For flux units (minima) reverse sign of observations. !! If algorithm detects poor phase coverage (bins with <CTMIN observations) !! it rebins observations into bins of near equal occupancy, by sorting !! observations in phase. This is a rare situation hence amounts to no !! significant slowing down. Thanks to this feature, for null frequency !! these routines return useful variability indicator as long as the sort !! routine is stable (e.g. merge sort). !! !! Advantage:<br> !! By checking and repairing phase coverage these routines perform robust and !! near-optimal period search, returnind spectrum of known classical !! probability distribution, equally well for small and large data. Slight !! statistical inefficiency stems from step-like function yielding slightly !! worse fit that equal size Fourier fit. This may be remedied by calling !! AOVMH/AOVMHV instead, at the speed cost. In terms of speed the present !! AOV/AOVW implementation is state-of-art as it employs pre-binning into !! NP*NCOV sub-bins and only afterwords combines subbins into suitably !! phased bins. See B. Enoch et al., 2012, A&A 548, A48 !! for independent evaluation of the present sub-bin algorithm. ! !! Copyrights and Distribution:<br> !! This package is subject to copyrights by its author, !! (C) A. Schwarzenberg-Czerny 2003-2018,  alex@camk.edu.pl !! Its distribution is free, except that distribution of modifications !! is prohibited. !! Please quote A. Schwarzenberg-Czerny & J.-Ph. Beaulieu, 2005, MNRAS 365, 165, !! while using AOV or AOVW. Integer :: aov !! status Real ( TIME ), Intent ( In ) :: t (:) !! times of observations Real ( SP ), Intent ( In ) :: vin (:) !! values of observations Real ( SP ), Intent ( In ) :: w (:) !! dummy Character ( Len =* ), Intent ( In ) :: sptype !! type of returned spectrum Integer , Intent ( In ) :: np !! number of phase bins Integer , Intent ( In ) :: ncov !! number of phase coverages Type ( SPEC_T ) :: spec !! frequency grid and result spectrum ! Integer :: nct (( Abs ( np ) + 1 ) * ncov ), ind ( size ( t )), i , ibin , ip , & nbc , ifr , iflex , npar , no Real ( SP ) :: ph ( size ( t )), v ( size ( t )), ave (( Abs ( np ) + 1 ) * ncov ), sav , v2 Real ( TIME ) :: fr , dph Logical :: transit ! aov = size ( w ) !! dummy use aov = 1 no = size ( t ) npar = Abs ( np ) transit = np < 0 ! ! normalize observations sav = sum ( vin ) / no v = vin - sav v2 = sum ( v ** 2 ) If ( no <= npar + npar ) Then If ( VERBOSE ) Print * , 'AOV: error: too few observations' Return End If ! nbc = npar * ncov !  Loop over all frequencies iflex = 0 Do ifr = 1 , spec % nfr ! Loop over frequencies fr = real ( ifr - 1 , kind = TIME ) * spec % frs + spec % fr0 Do ip = 0 , 1 ave = 0._SP nct = 0 If ( ip == 0 ) Then ! Try default fixed bins ... Do i = 1 , no ! MOST LABOR HERE dph = t ( i ) * fr ! real(TIME) :: dph, t, fr dph = dph - floor ( dph ) ph ( i ) = real ( dph , SP ) ibin = Int ( dph * nbc ) + 1 ave ( ibin ) = ave ( ibin ) + v ( i ) nct ( ibin ) = nct ( ibin ) + 1 End Do Else !... elastic bins, if necesseary iflex = iflex + 1 ! sort index ind using key ph Call sortx ( ph , ind ) ! NRf77 indexx would do Do i = 1 , no ibin = i * nbc / no + 1 ave ( ibin ) = ave ( ibin ) + v ( ind ( i )) nct ( ibin ) = nct ( ibin ) + 1 End Do End If ! counts: sub-bins=>bins nct ( 1 + nbc : ncov + nbc ) = nct ( 1 : ncov ) i = 0 Do ibin = ncov + nbc , 1 , - 1 i = i + nct ( ibin ) nct ( ibin ) = i End Do Do ibin = 1 , nbc nct ( ibin ) = nct ( ibin ) - nct ( ibin + ncov ) End Do If ( minval ( nct ( 1 : nbc )) >= CTMIN ) Exit End Do ! data: sub-bins=>bins */ ave ( 1 + nbc : ncov + nbc ) = ave ( 1 : ncov ) sav = 0._SP Do ibin = ncov + nbc , 1 , - 1 sav = sav + ave ( ibin ) ave ( ibin ) = sav End Do Do ibin = 1 , nbc ave ( ibin ) = ave ( ibin ) - ave ( ibin + ncov ) End Do ! If ( transit ) Then ! statistics for transits ... ave ( 1 : nbc ) = ave ( 1 : nbc ) / nct ( 1 : nbc ) ibin = maxloc ( ave ( 1 : nbc ), dim = 1 ) sav = ave ( ibin ) sav = sav * sav * nct ( ibin ) * no / real ( no - nct ( ibin ), kind = SP ) Else ! the same for the classical AoV statistics: sav = sum ( ave ( 1 : nbc ) ** 2 / nct ( 1 : nbc )) / ncov End If spec % th ( ifr ) = sav End Do i = npar If ( transit ) i = 2 ! If ( VERBOSE . And . iflex > 0 ) Print * , & 'AOV:warning: poor phase coverage at ' , iflex , ' frequencies' Call spectrum ( sptype , no , i , v2 , spec ) aov = 0 End Function aov ! Function aovw ( sptype , t , vin , win , np , ncov , spec ) !! Routine for phase folding and binning of observations using weights ! !! Purpose:<br> !! The state-of-art routines for either period search by phase folding and !! binning of observations (for NP>0) or for search for periodic transits/pulses !! of short duty cycle, with constat signal elsewhere (for NP<0). In the latter !! case data are fitted with just two unequal phase bins: in- and out-of transit. ! !! Method:<br> !! In any case observations are phase folded and binned into NP equal phase !! bins starting at NCOV sub-bin phases. Subsequently the algorithm !! either sums squares of bin averages (for NP>0). For transit search !! (NP<0) algorithm searches for the maximum value phase bin (considered !! in-transit for magnitude units). Its squared value and identities stemming !! from Parceval theorem are employed to evaluate sum of squares for two !! phase-bins in- and out-of transit. Note: here transits are defined as MAXIMA !! (i.e. in magnitude units). For flux units (minima) reverse sign of observations. !! If algorithm detects poor phase coverage (bins with <CTMIN observations) !! it rebins observations into bins of near equal occupancy, by sorting !! observations in phase. This is a rare situation hence amounts to no !! significant slowing down. Thanks to this feature, for null frequency !! these routines return useful variability indicator as long as the sort !! routine is stable (e.g. merge sort). !! !! Advantage:<br> !! By checking and repairing phase coverage these routines perform robust and !! near-optimal period search, returnind spectrum of known classical !! probability distribution, equally well for small and large data. Slight !! statistical inefficiency stems from step-like function yielding slightly !! worse fit that equal size Fourier fit. This may be remedied by calling !! AOVMH/AOVMHV instead, at the speed cost. In terms of speed the present !! AOV/AOVW implementation is state-of-art as it employs pre-binning into !! NP*NCOV sub-bins and only afterwords combines subbins into suitably !! phased bins. See B. Enoch et al., 2012, A&A 548, A48 !! for independent evaluation of the present sub-bin algorithm. ! !! Copyrights and Distribution:<br> !! This package is subject to copyrights by its author, !! (C) A. Schwarzenberg-Czerny 2003-2018,  alex@camk.edu.pl !! Its distribution is free, except that distribution of modifications !! is prohibited. !! Please quote A. Schwarzenberg-Czerny & J.-Ph. Beaulieu, 2005, MNRAS 365, 165, !! while using AOV or AOVW. Integer :: aovw !! status Real ( TIME ), Intent ( In ) :: t (:) !! times of observations Real ( SP ), Intent ( In ) :: vin (:) !! values of observations Real ( SP ), Intent ( In ) :: win (:) !! weights of observations Character ( Len =* ), Intent ( In ) :: sptype !! type of returned spectrum Integer , Intent ( In ) :: np !! number of phase bins Integer , Intent ( In ) :: ncov !! number of phase coverages Type ( SPEC_T ) :: spec !! frequency grid and result spectrum ! Integer :: ind ( size ( t )), i , ibin , ip , nbc , ifr , iflex , npar , & no , noeff Real ( SP ) :: ph ( size ( t )), v ( size ( t )), w ( size ( t )), sav , ctw , sw , & nct (( Abs ( np ) + 1 ) * ncov ), ave (( Abs ( np ) + 1 ) * ncov ), v2 Real ( TIME ) :: fr , dph Logical :: transit ! aovw = 1 no = size ( t ) npar = Abs ( np ) transit = np < 0 ! ! normalize observations w = 0._SP Where ( win > 0._SP ) w = win noeff = count ( w > 0. ) sw = sum ( w ) v = vin - sum ( vin * w ) / sw v2 = sum ( w * v ** 2 ) v = v * w If ( noeff <= npar + npar . Or . noeff < CTMIN * npar ) Then If ( VERBOSE ) Print * , 'AOVw: error: too few observations' Return End If ! nbc = npar * ncov iflex = 0 ctw = CTMIN * sw / noeff Do ifr = 1 , spec % nfr ! Loop over frequencies fr = real ( ifr - 1 , kind = TIME ) * spec % frs + spec % fr0 Do ip = 0 , 1 ave = 0._SP nct = 0._SP If ( ip == 0 ) Then ! Try default fixed bins ... Do i = 1 , no ! MOST LABOR HERE dph = t ( i ) * fr ! real(TIME) :: dph, t, fr dph = dph - floor ( dph ) ph ( i ) = real ( dph , SP ) ! note: mod accounts for rounding up due to double-->real conversion ibin = Int ( dph * nbc ) + 1 ave ( ibin ) = ave ( ibin ) + v ( i ) nct ( ibin ) = nct ( ibin ) + w ( i ) End Do Else !... elastic bins, if necesseary ! iflex = iflex + 1 ! sort index ind using key ph Call sortx ( ph , ind ) ! NRf77 indexx would do Do i = 1 , no ibin = i * nbc / no + 1 ave ( ibin ) = ave ( ibin ) + v ( ind ( i )) nct ( ibin ) = nct ( ibin ) + w ( ind ( i )) End Do End If ! counts: sub-bins=>bins nct ( 1 + nbc : ncov + nbc ) = nct ( 1 : ncov ) sav = 0._SP Do ibin = ncov + nbc , 1 , - 1 sav = sav + nct ( ibin ) nct ( ibin ) = sav End Do Do ibin = 1 , nbc nct ( ibin ) = nct ( ibin ) - nct ( ibin + ncov ) End Do If ( minval ( nct ( 1 : nbc )) >= ctw ) Exit End Do ! data: sub-bins=>bins */ ave ( 1 + nbc : ncov + nbc ) = ave ( 1 : ncov ) sav = 0._SP Do ibin = ncov + nbc , 1 , - 1 sav = sav + ave ( ibin ) ave ( ibin ) = sav End Do Do ibin = 1 , nbc ave ( ibin ) = ave ( ibin ) - ave ( ibin + ncov ) End Do ! If ( transit ) Then ! AoV statistics for transits ... ave ( 1 : nbc ) = ave ( 1 : nbc ) / nct ( 1 : nbc ) ibin = maxloc ( ave ( 1 : nbc ), dim = 1 ) sav = ave ( ibin ) sav = sav * sav * nct ( ibin ) * sw / ( sw - nct ( ibin )) Else ! the same for the classical AoV statistics: sav = sum ( ave ( 1 : nbc ) ** 2 / nct ( 1 : nbc )) / ncov End If spec % th ( ifr ) = sav End Do i = npar If ( transit ) i = 2 ! Call spectrum ( sptype , noeff , i , v2 , spec ) ! If ( VERBOSE . And . iflex > 0 ) Print * , & 'AOVw:warning: poor phase coverage at ' , iflex , ' frequencies' aovw = 0 End Function aovw ! End of AOV & AOVW routines !========================================================================== ! POWSP & POWSPW routines returning two different versions of power spectrum ! Function powsp ( sptype , t , vin , w , npar , ncov , spec ) ! !!Purpose:<br> !!POWSP - returns discrete power spectrum (DPS) for unevenly sampled !!observations. For obs.v==1 calculates window function (WF). !!SPTYPE, NPAR and NCOV are ignored. The normalization factor is 1/NOBS**2, !!suitable for WF. Power is defined in a usual way as sum of squares of !!projections onto sine and cosine functions. This concept does not extend !!on weighted observations, hence POWSPW employs different algorithm.<br> !!Reference: T.Deeming, 1975, Ap&SS 36, 137. !! !!  Copyrights and Distribution:<br> !!  This routine is subject to copyrights by its author, !!  (C) A. Schwarzenberg-Czerny 1998-2018,  alex@camk.edu.pl !!  Its distribution is free, except that distribution of modifications is !!  prohibited. Integer :: powsp !! status Real ( TIME ), Intent ( In ) :: t (:) !! times of observations Real ( SP ), Intent ( In ) :: vin (:) !! values of observations Real ( SP ), Intent ( In ) :: w (:) !! dummy Integer , Intent ( In ) :: npar !! dummy Integer , Intent ( In ) :: ncov !! dummy Character ( Len =* ), Intent ( In ) :: sptype !! dummy Type ( SPEC_T ) :: spec !! frequency grid and result spectrum ! Integer :: l , no Real ( SP ) :: fac , v ( size ( t )) Real ( TIME ) :: ph ( size ( t )) ! powsp = ncov + npar + len ( sptype ) + size ( w ) ! dummy use powsp = 1 no = size ( t ) ! normalize observations v = vin - sum ( vin ) / no If ( no . Lt . 4 ) Then If ( VERBOSE ) Print * , 'POWSP:error: wrong size of arrays' Return End If ! fac = 1._SP / no ** 2 Do l = 1 , spec % nfr ph = ( spec % frs * ( l - 1 ) + spec % fr0 ) * t !   (f,g)=sum(w*conjg(f)*g) -definition ph = PI2 * ( ph - floor ( ph )) spec % th ( l ) = Abs ( sum ( v * cmplx ( Cos ( ph ), Sin ( ph ), kind = CP ))) ** 2 * fac End Do powsp = 0 End Function powsp ! Function powspw ( sptype , t , vin , win , npar , ncov , spec ) ! !!Purpose: !!POWSPW - returns discrete power spectrum (DPS) for weighted unevenly sampled !!observations defined differently than in POWSP. No window function (WF) is !!available and NPAR and NCOV are ignored. The algorithm by weighted least !!squares fits data with Asin(om*t)+Bcos(om*t) and for each frequency returns !!A**2+B**2. The normalization is peculiar to this implementation and depends !!on time sampling. !!Reference: S. T. Fletcher et al., 2011, MNRAS 415, 1310 (see Appendix). !! !!  Copyrights and Distribution: !!  This routine is subject to copyrights by its author, !!  (C) A. Schwarzenberg-Czerny 2018,  alex@camk.edu.pl !!  Its distribution is free, except that distribution of modifications is !!  prohibited. Integer :: powspw !! status Real ( TIME ), Intent ( In ) :: t (:) !! times of observations Real ( SP ), Intent ( In ) :: vin (:) !! values of observations Real ( SP ), Intent ( In ) :: win (:) !! weights of observations Integer , Intent ( In ) :: npar !! dummy Integer , Intent ( In ) :: ncov !! dummy Character ( Len =* ), Intent ( In ) :: sptype !! dummy Type ( SPEC_T ) :: spec !! frequency grid and result spectrum ! Integer :: l , no Real ( SP ), Dimension ( size ( t )) :: c , s , v , w Real ( SP ) :: sx , cx , ss , cc , sc Real ( TIME ) :: dph ( size ( t )) ! powspw = Int ( ncov + npar + len ( sptype )) ! dummy use powspw = 1 ! normalize observations w = 0._SP Where ( win > 0._SP ) w = win no = count ( w > 0._SP ) v = ( vin - sum ( vin * w ) / sum ( w )) * w If ( no . Lt . 4 ) Then If ( VERBOSE ) Print * , 'POWSPW:error: wrong size of arrays' Return End If ! Do l = 1 , spec % nfr dph = ( spec % frs * ( l - 1 ) + spec % fr0 ) * t s = real ( PI2 * ( dph - floor ( dph )), SP ) c = Cos ( s ) s = Sin ( s ) sx = sum ( s * v ) cx = sum ( c * v ) ss = sum ( w * s ** 2 ) cc = sum ( w * c ** 2 ) sc = sum ( w * c * s ) spec % th ( l ) = 0.25_SP * (( sx * cc - cx * sc ) ** 2 + ( cx * ss - sx * sc ) ** 2 ) / & Max (( ss * cc - sc * sc ) ** 2 , TINY ( ss )) End Do powspw = 0 End Function powspw ! End of POWSP & POWSPW routines !======================================================== Function aovdrv ( method , sptype , t , v , w , npar , ncov , spec ) !! AOVDRV driver routine for `AovPer` frequency spectrum routines !! Purpose: example calling of spectrum routines. Integer :: aovdrv !! status Character ( Len =* ), Intent ( In ) :: method !! periodogram method Character ( Len =* ), Intent ( In ) :: sptype !! type of returned spectrum Real ( TIME ), Intent ( In ) :: t (:) !! times Real ( SP ), Intent ( In ) :: v (:) !! values Real ( SP ), Intent ( In ) :: w (:) !! weights or errors, depending on ERRIN Integer , Intent ( In ) :: npar !! number of parameters Integer , Intent ( In ) :: ncov !! number of phase coverages Type ( SPEC_T ) :: spec !! frequency grid and result spectrum ! Integer :: i ! get spectrum/periodogram Select Case ( trim ( method )) Case ( 'AOV' ) i = aov ( sptype , t , v , w , Max ( 2 , npar ), ncov , spec ) Case ( 'ATR' ) i = aov ( sptype , t , v , w , - Max ( 2 , npar ), ncov , spec ) Case ( 'AMH' ) i = aovmh ( sptype , t , v , w , Max ( 2 , npar ), ncov , spec ) Case ( 'PWS' ) i = powsp ( sptype , t , v , w , Max ( 2 , npar ), ncov , spec ) Case ( 'AOVW' ) i = aovw ( sptype , t , v , w , Max ( 2 , npar ), ncov , spec ) Case ( 'ATRW' ) i = aovw ( sptype , t , v , w , - Max ( 2 , npar ), ncov , spec ) Case ( 'AMHW' ) i = aovmhw ( sptype , t , v , w , Max ( 2 , npar ), ncov , spec ) Case ( 'PWSW' ) i = powspw ( sptype , t , v , w , Max ( 2 , npar ), ncov , spec ) Case Default If ( VERBOSE ) Print * , 'aovdrv: error: Wrong mode' Stop End Select aovdrv = i End Function aovdrv ! End Module aovper","tags":"","loc":"sourcefile/aovper.f90.html"},{"title":"aovsub.f90 – Aov","text":"Contents Modules aovsub Source Code aovsub.f90 Source Code Module aovsub !! Utility routines for Aov.<br> !! Note that only `public` routines are reliable and tested. !! Other ones are kept here for past/future development. ! Use aovconst ! Implicit None ! Private Public sortx , givensacc , givens , tolower , toupper , dict_val Interface sortx Module Procedure sortx_m_r4 , sortx_m_r8 End Interface sortx ! Character ( Len =* ), Parameter :: Lowcase = 'abcdefghijklmnopqrstuvwxyz' Character ( Len =* ), Parameter :: Upcase = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' ! Contains ! Function dict_val ( dict , isize , key ) !! Find key position in a keyword dictionary. !! Restriction: dictionary entries are of equal size, !! all kept in one string. Integer :: dict_val !! Key position Character ( Len =* ), Intent ( In ) :: dict !! Dictionary string Character ( Len =* ), Intent ( In ) :: key !! key string Integer , Intent ( In ) :: isize !! size of keys dict_val = index ( dict , key ) If ( dict_val > 0 ) dict_val = dict_val / isize + 1 End Function dict_val ! ! Function tolower ( str ) !! Change string case to lower Character ( Len =* ), Intent ( In ) :: str !! input string Character ( Len = Len ( str )) :: tolower !! result output string ! Integer l , i , j l = len ( str ) tolower = str Do i = 1 , l j = index ( Upcase , tolower ( i : i )) If ( j > 0 ) tolower ( i : i ) = Lowcase ( j : j ) End Do End Function tolower ! Function toupper ( str ) !! Change string case to upper Character ( Len =* ), Intent ( In ) :: str !! input string Character ( Len = Len ( str )) :: toupper !! result output string ! Integer l , i , j l = len ( str ) toupper = str Do i = 1 , l j = index ( Lowcase , toupper ( i : i )) If ( j > 0 ) toupper ( i : i ) = Upcase ( j : j ) End Do End Function toupper ! Subroutine givensacc ( a , r ) !! Purpose: GIVENSACC prepares the least squares solution (LSQ) of an !! overdetermined linear system by Givens rotations, a state-of-art !! algorithm. Routine takes current observation equation from a and !! accumulates it into r: !! (C) Alex Schwarzenberg-Czerny,2000      alex@camk.edu.pl Implicit None Real ( SP ), Intent ( In ) :: a (:) !! a(n1)    - an equation with its RHS as a(n1) element, !!            multiplied by sqrt of weight. !!            Note: sum of all weights must equall no.observations, !!            lest GIVENS returns wrong covariance estimates. Real ( SP ), Intent ( Inout ) :: r (:, :) !! Input: r(n1,n1) - triangle system R and its R.H.S !!            set r = 0 before te first call of GIVENSACC. !! Output: r(n1,n1) - updated system accounting of a Integer :: n1 , n , i , j Real ( SP ) :: e ( size ( a )), p , q , s , rii , ei n1 = size ( a ) n = n1 - 1 e = a r ( n1 , n1 ) = r ( n1 , n1 ) + e ( n1 ) * e ( n1 ) Do i = 1 , n rii = r ( i , i ) ei = e ( i ) s = rii * rii + ei * ei If ( s <= 0._SP ) Then p = 1._SP q = 0._SP Else s = sign ( Sqrt ( s ), rii ) p = rii / s q = ei / s End If r ( i , i ) = s e ( i ) = 0._SP Do j = i + 1 , n1 s = q * e ( j ) + p * r ( i , j ) e ( j ) = p * e ( j ) - q * r ( i , j ) r ( i , j ) = s End Do End Do ! End Subroutine givensacc ! Function givens ( r , idf , detnth ) !! Purpose: GIVENS calculates the least squares solution of an !! overdetermined linear system by accurate Givens rotations. !! Prior to GIVENS call m-times GIVENSA in order to build the !! triangle system R !! (C) Alex Schwarzenberg-Czerny,2000      alex@camk.edu.pl Implicit None Real ( SP ) :: givens !! result condition ratio (min eigenv/max eigenv), !! 0 signalls singular system Integer , Intent ( In ) :: idf !! idf - >0 solve normal equations for idf degrees of freedom !!       <0 and r(n1,n1)=1: inverse triangle matrix R Real ( SP ), Intent ( Inout ) :: r (:, :) !! Input: r(n1,n1) - triangle system R and its R.H.S !! Output: For idf>0: !! r(n1,:)   - unknowns !! (r(k,k),k=1,n) variances !! (r(:k,k),k=1,n) half of covariance matrix !! (r(k+1:,k),k=2,n) half of inverse triangle root Q !! r(n1,n1) - chi&#94;2/idf (=RHS variance=std.dev&#94;2) !!         For idf<0: !! ((r(j,k),j=1,k),k=1,n) inverse triangle root  Q Real ( SP ), Intent ( Out ) :: detnth !! =Det(R)&#94;(1/n) - n-th root of determinant ! Integer :: n1 , n , i , j Real ( SP ), Parameter :: tol = 3 0._SP * epsilon ( 1._SP ) Real ( SP ) :: rii , riimx , riimn ! n1 = size ( r , dim = 1 ) n = n1 - 1 r ( n1 , n1 ) = ( r ( n1 , n1 ) - dot_product ( r ( 1 : n , n1 ), r ( 1 : n , n1 ))) / & Max ( 1 , idf ) Do i = 1 , n rii = 0._SP If ( Abs ( r ( i , i )) > tol ) rii = 1._SP / r ( i , i ) r ( i , i ) = - 1._SP Do j = 1 , i r ( i , j ) = r ( i , j ) * rii r ( i + 1 , j ) = - dot_product ( r ( j : i , j ), r ( j : i , i + 1 )) !en(j,i+1)=-dot_product(en(j,k:i),en(i+1,k:i)) End Do End Do !Already solved, square Q to get  inverse/covariance detnth = 0. riimx = Abs ( r ( 1 , 1 )) riimn = riimx Do i = 1 , n rii = Abs ( r ( i , i )) If ( idf . Gt . 0 ) Then Do j = 1 , i r ( j , i ) = dot_product ( r ( i : n , i ), r ( i : n , j )) * r ( n1 , n1 ) End Do End If If ( rii > 0._SP ) Then detnth = detnth - Log ( rii ) End If riimx = Max ( rii , riimx ) riimn = Min ( rii , riimn ) End Do givens = riimn / riimx detnth = Exp ( 2._SP * detnth / n ) ! End Function givens ! Subroutine sortx_h ( dat , ind ) !! (C) Alex Schwarzenberg-Czerny, 2001,2005 alex@camk.edu.pl !! Unstable index sorting. Method based on heap sort routine in !! Numerical Recipes, 1992, Press et al., Cambridge U.P. Implicit None Real ( SP ), Intent ( In ) :: dat (:) !! unsorted data Integer , Intent ( Out ) :: ind (:) !! sort index ! Integer :: i , j , n n = size ( dat ) If ( size ( ind ) < n ) Then Write ( * , * ) 'sortx_h: wrong dimension' Stop End If ! Do i = 1 , n ind ( i ) = i End Do ! Do i = n / 2 , 1 , - 1 Call put ( i , n ) End Do Do i = n , 2 , - 1 j = ind ( 1 ) ind ( 1 ) = ind ( i ) ind ( i ) = j Call put ( 1 , i - 1 ) End Do ! Contains ! Subroutine put ( low , up ) ! Swap index values when needed ! Auxillary routine for hep sort ! ind,dat are global Integer , Intent ( In ) :: low ! lower index Integer , Intent ( In ) :: up ! upper index ! Integer :: i , j , jsav Real ( SP ) :: sav jsav = ind ( low ) sav = dat ( jsav ) j = low i = low + low Do If ( i > up ) Exit If ( i < up ) Then If ( dat ( ind ( i )) < dat ( ind ( i + 1 ))) i = i + 1 End If If ( sav >= dat ( ind ( i ))) Exit ind ( j ) = ind ( i ) j = i i = i + i End Do ind ( j ) = jsav ! End Subroutine put ! End Subroutine sortx_h ! Subroutine sortx_m_r4 ( dat , ina ) !! (C) Alex Schwarzenberg-Czerny, 2005      alex@camk.edu.pl !! Stable index sorting by merge sort. Requires extra memory (inb) Implicit None Real ( 4 ), Intent ( In ) :: dat (:) !! unsorted data Integer , Intent ( Out ) :: ina (:) !! sort index ! Integer :: inb (( size ( dat ) + 1 ) / 2 ), i , n ! n = size ( dat ) If ( size ( ina ) < n ) Then Write ( * , * ) 'sortx_m: wrong dimension' Stop End If ! Forall ( i = 1 : n ) ina ( i ) = i ! Call sort_part ( 1 , n ) ! Contains ! Recursive Subroutine sort_part ( low , up ) ! Sort part of data between incdices ! Auxillary recursive subroutine for merge sort Integer , Intent ( In ) :: low ! lower sort index Integer , Intent ( In ) :: up ! upper sort index ! Integer :: med ! If ( low < up ) Then med = ( low + up ) / 2 Call sort_part ( low , med ) Call sort_part ( med + 1 , up ) Call merge_part ( low , med , up ) End If End Subroutine sort_part ! Subroutine merge_part ( low , med , up ) !! merge 2 sorted parts, divided by med Integer , Intent ( In ) :: low !! lower index Integer , Intent ( In ) :: med !! middle index Integer , Intent ( In ) :: up !! upper index ! Integer :: i , j , r ! inb ( 1 : med - low + 1 ) = ina ( low : med ) ! i = 1 r = low j = med + 1 Do If ( r >= j . Or . j > up ) Exit If ( dat ( inb ( i )) <= dat ( ina ( j ))) Then ina ( r ) = inb ( i ) i = i + 1 Else ina ( r ) = ina ( j ) j = j + 1 End If r = r + 1 End Do ! ina ( r : j - 1 ) = inb ( i : i + j - 1 - r ) End Subroutine merge_part ! End Subroutine sortx_m_r4 ! Subroutine sortx_m_r8 ( dat , ina ) !! (C) Alex Schwarzenberg-Czerny, 2005      alex@camk.edu.pl !! Stable index sorting by merge sort. Requires extra memory (inb) Implicit None Real ( 8 ), Intent ( In ) :: dat (:) !! unsorted data Integer , Intent ( Out ) :: ina (:) !! sort index ! Integer :: inb (( size ( dat ) + 1 ) / 2 ), i , n ! n = size ( dat ) If ( size ( ina ) < n ) Then Write ( * , * ) 'sortx_m: wrong dimension' Stop End If ! Forall ( i = 1 : n ) ina ( i ) = i ! Call sort_part ( 1 , n ) ! Contains ! Recursive Subroutine sort_part ( low , up ) ! Sort part of data between incdices ! Auxillary recursive subroutine for merge sort Integer , Intent ( In ) :: low ! lower sort index Integer , Intent ( In ) :: up ! upper sort index ! Integer :: med ! If ( low < up ) Then med = ( low + up ) / 2 Call sort_part ( low , med ) Call sort_part ( med + 1 , up ) Call merge_part ( low , med , up ) End If End Subroutine sort_part ! Subroutine merge_part ( low , med , up ) ! merge 2 sorted parts, divided by med ! Auxillary subroutine for merge sort Integer , Intent ( In ) :: low ! lower index Integer , Intent ( In ) :: med ! middle index Integer , Intent ( In ) :: up ! upper index ! Integer :: i , j , r ! inb ( 1 : med - low + 1 ) = ina ( low : med ) ! i = 1 r = low j = med + 1 Do If ( r >= j . Or . j > up ) Exit If ( dat ( inb ( i )) <= dat ( ina ( j ))) Then ina ( r ) = inb ( i ) i = i + 1 Else ina ( r ) = ina ( j ) j = j + 1 End If r = r + 1 End Do ! ina ( r : j - 1 ) = inb ( i : i + j - 1 - r ) End Subroutine merge_part ! End Subroutine sortx_m_r8 ! Subroutine covar ( t1 , v1 , e1 , t2 , v2 , e2 , nlag , eps , iscale , & & ifunct , n1 , n2 , lav , lmi , lmx , cc , cmi , cmx ) !! TO BE DONE: !! -more flexibility in choosing the lag grid !! Purpose: !! Calculates cross-correlation function(CCF) of two time series sampled unevenly !! in time. Note that for good result each hump in the time series should be covered !! by several observations (over-sampling). !! !! Method/Reference: !! \\bibitem[Alexander(1997)]{1997ASSL..218..163A} !! Alexander, T.\\ 1997, Astronomical Time Series, !! Eds. D. Maoz, A. Sternberg, and E.M. Leibowitz, 1997 (Dordrecht: Kluwer),218, 163 !! Title: Is AGN Variability Correlated with Other AGN Properties? ZDCF Analysis of !! Small Samples of Sparse Light Curves ! !!  Copyrights and Distribution: !!  This package is subject to copyrights by its author, !!  (C) A. Schwarzenberg-Czerny 2011,  alex@camk.edu.pl ! Integer , Intent ( In ) :: iscale !!   (ignored)output scale: /=1 -linear; ==1 -logarythmic Integer , Intent ( In ) :: ifunct !!   (ignored)output function: /=1 -correlation; ==1 -structure Real ( SP ), Intent ( In ) :: eps !!   max separation within lag Integer , Intent ( In ) :: n1 !!    number of observations in 1st set Real ( TIME ), Intent ( In ) :: t1 ( n1 ) !!   1st set times Real ( SP ), Intent ( In ) :: v1 ( n1 ) !!   1st set values Real ( SP ), Intent ( In ) :: e1 ( n1 ) !!   1st set errors Integer , Intent ( In ) :: n2 !!    number of observations in 2nd set Real ( TIME ), Intent ( In ) :: t2 ( n2 ) !!   2nd set times Real ( SP ), Intent ( In ) :: v2 ( n2 ) !!   2nd set values Real ( SP ), Intent ( In ) :: e2 ( n2 ) !!   2nd set errors Integer , Intent ( In ) :: nlag !!   number of lags Real ( SP ), Intent ( Out ) :: cc ( nlag ) !! average of correlations Real ( SP ), Intent ( Out ) :: cmi ( nlag ) !! min of correlations Real ( SP ), Intent ( Out ) :: cmx ( nlag ) !! max of correlations Real ( SP ), Intent ( Out ) :: lav ( nlag ) !! average of lags Real ( SP ), Intent ( Out ) :: lmi ( nlag ) !! min of lags Real ( SP ), Intent ( Out ) :: lmx ( nlag ) !! max of lags ! f2py Integer,Intent(IN),optional   :: iscale=0,ifunct=0 ! f2py Real(SP),Intent(IN),optional  :: eps=0. ! Integer :: ind ( n1 * n2 ), mdt , mbin , mct , idt , ibin , ict , i , i1 , & & i2 , nct , ib1 ( 2 * n1 * n2 / nlag ), ib2 ( 2 * n1 * n2 / nlag ) Real ( SP ) :: dt ( n1 * n2 ), z , s , r , r2 , ad1 , ad2 , sd1 , sd2 , sw ! n1*n2 could be large Real ( SP ), Allocatable :: db1 (:), db2 (:), wb1 (:), wb2 (:), & & wb (:), cb (:), lags (:) ! mdt = iscale + ifunct ! use dummy variables to prevent warnings mdt = n1 * n2 nct = mdt / nlag mbin = mdt / nct mct = 2 * nct lav = 0._SP lmi = 0._SP lmx = 0._SP cc = 0._SP cmi = 0._SP cmx = 0._SP ! Forall ( i1 = 1 : n1 , i2 = 1 : n2 ) dt (( i1 - 1 ) * n2 + i2 ) = real & & ( t2 ( i2 ) - t1 ( i1 ), SP ) Call sortx ( dt , ind ) ! idt = 0 ibin = 0 Do ! increment bins If ( ibin >= mbin ) Exit ibin = ibin + 1 ict = 0 ! Do ! increment pairs If ( idt >= mdt ) Exit idt = idt + 1 ! check If lag bin finished If ( ict > nct . And . dt ( ind ( idt )) - dt ( ind ( Max ( 1 , idt - 1 ))) & & > eps . And . mdt - idt > nct / 2 ) Exit i1 = ind ( idt ) / n2 + 1 i2 = ind ( idt ) - ( i1 - 1 ) * n2 ! Do i = 1 , ict ! check dependence If ( ib1 ( i ) == i1 . Or . ib2 ( i ) == i2 ) Exit End Do If ( i <= ict ) Then ! dependent If ( e1 ( i1 ) * e2 ( i2 ) < e1 ( ib1 ( i )) * e2 ( ib2 ( i ))) Then ib1 ( i ) = i1 ib2 ( i ) = i2 End If Else ! independent If ( ict >= mct ) Exit ! this should never happen ict = ict + 1 ib1 ( ict ) = i1 ib2 ( ict ) = i2 End If End Do ! ! evaluate correlation within a bin Allocate ( db1 ( ict ), db2 ( ict ), wb1 ( ict ), wb2 ( ict ), wb ( ict ), & cb ( ict ), lags ( ict )) db1 = v1 ( ib1 (: ict )) wb1 = 0._SP Where ( e1 ( ib1 (: ict )) > 0._SP ) wb1 = 1._SP / e1 ( ib1 (: ict )) ** 2 db2 = v2 ( ib2 (: ict )) wb2 = 0._SP Where ( e2 ( ib2 (: ict )) > 0._SP ) wb2 = 1._SP / e2 ( ib2 (: ict )) ** 2 wb = Sqrt ( wb1 * wb2 ) sw = sum ( wb ) ! ad1 = sum ( db1 * wb1 ) / sum ( wb1 ) db1 = db1 - ad1 ! data variance and averages ad2 = sum ( db2 * wb2 ) / sum ( wb2 ) db2 = db2 - ad2 sd1 = sum ( db1 ** 2 * wb1 ) sd2 = sum ( db2 ** 2 * wb2 ) ! ! correlation and its variance in z-variable r = sum ( db1 * db2 * wb ) / Sqrt ( sd1 * sd2 ) cc ( ibin ) = r r2 = r * r z = ((((( r2 * 3._SP + 2._SP ) * r2 + 1 1._SP ) * 0.5_SP / ( ict - 1 ) + r2 + 5._SP ) * & 0.25 / ( ict - 1 ) + 1._SP ) * r / ( ict - 1 ) + Log ( Max ( 1._SP - r , tiny ( z )) / & ( 1._SP + r ))) * 0.5_SP s = Sqrt ((((( - r2 * 3._SP - 6._SP ) * r2 + 2 2._SP ) / 3._SP / ( ict - 1 ) + 4._SP - r2 ) & * 0.5 / ( ict - 1 ) + 1._SP ) / ( ict - 1 )) cmi ( ibin ) = r - Abs ( Tanh ( z - s ) - r ) cmx ( ibin ) = r + Abs ( Tanh ( z + s ) + r ) ! lags = real ( t2 ( ib2 (: ict )) - t1 ( ib1 (: ict )), SP ) ! average & extreme intervals lav ( ibin ) = sum ( lags * wb ) / sw lmx ( ibin ) = maxval ( lags ) lmi ( ibin ) = minval ( lags ) Deallocate ( db1 , db2 , wb1 , wb2 , wb , cb , lags ) ! If ( idt >= mdt ) Exit End Do End Subroutine covar ! Subroutine covar1 ( t1 , d1 , v1 , t2 , d2 , v2 , nlag , lag0 , lstep , & & iscale , ifunct , n1 , n2 , lgs , cc , cv , av1 , var1 , av2 , var2 ) !!   Compute discrete covariance function for unequaly sampled signals !!   Reference: Edelson R.A. and Krolik, J.H., 1988, ApJ 333, 646 !! this routine is incorrect (weighting not implementrd fully/correctly) !!  Copyrights and Distribution: !!  This package is subject to copyrights by its author, !!  (C) A. Schwarzenberg-Czerny 1998-2011,  alex@camk.edu.pl ! Integer , Intent ( In ) :: iscale !!   (ignored)output scale: /=1 -linear; ==1 -logarythmic Integer , Intent ( In ) :: ifunct !!   (ignored)output function: /=1 -correlation; ==1 -structure Integer , Intent ( In ) :: n1 !!   number of observations in 1st set Real ( TIME ), Intent ( In ) :: t1 ( n1 ) !!   1st set times Real ( SP ), Intent ( In ) :: d1 ( n1 ) !!   1st set values Real ( SP ), Intent ( In ) :: v1 ( n1 ) !!   1st set variances Integer , Intent ( In ) :: n2 !!   number of observations in 2nd set Real ( TIME ), Intent ( In ) :: t2 ( n2 ) !!   2nd set times Real ( SP ), Intent ( In ) :: d2 ( n2 ) !!   2nd set values Real ( SP ), Intent ( In ) :: v2 ( n2 ) !!   2nd set variances Integer , Intent ( In ) :: nlag !!   number of lags Real ( TIME ), Intent ( In ) :: lag0 !!   first time lag Real ( TIME ), Intent ( In ) :: lstep !!   lag increment Real ( SP ), Intent ( Out ) :: lgs ( nlag ) !! time lag Real ( SP ), Intent ( Out ) :: cc ( nlag ) !! covariance Real ( SP ), Intent ( Out ) :: cv ( nlag ) !! its variance Real ( SP ), Intent ( Out ) :: av1 !! average 1-st set Real ( SP ), Intent ( Out ) :: var1 !! variance 1-st set Real ( SP ), Intent ( Out ) :: av2 !! average 2-nd set Real ( SP ), Intent ( Out ) :: var2 !! variance 2-nd set ! Integer :: iobs1 , iobs2 , ilag !  Real(SP)   :: s1(n1),s2(n2) Real ( SP ) :: ct1 , ct2 , cnt , oldaver , aver , v , vi , ei , var12 , t , & tlow , tup , tlag0 Real ( TIME ) :: ti ! If ( lstep <= 0. ) Then Print * , 'COVAR: lstep must be positive' Return End If tlow = lag0 tup = lag0 + ( nlag - 1 ) * lstep ! lag scale range If ( iscale == 1 ) Then If ( lag0 <= 0. ) Then Print * , 'COVAR: lag0 must be positive for log scale' Return End If tlow = 1 0._SP ** tlow tup = 1 0._SP ** tup ! de-log lag scale range End If !   Compute weighted averages and variances ! ct1 = sum ( 1._SP / v1 ) ct2 = sum ( 1._SP / v2 ) av1 = sum ( d1 / v1 ) / ct1 av2 = sum ( d2 / v2 ) / ct2 var1 = sum (( d1 - av1 ) ** 2 / v1 ) / ( n1 - 1 ) * n1 / ct1 var2 = sum (( d2 - av2 ) ** 2 / v2 ) / ( n2 - 1 ) * n2 / ct2 var12 = Sqrt ( var1 * var2 ) ! !   Compute binned discrete covariance function cc = 0._SP cv = 0._SP lgs = 0._SP tlag0 = lag0 Do iobs1 = 1 , n1 ! loop over data 1 ti = t1 ( iobs1 ) vi = d1 ( iobs1 ) - av1 ei = v1 ( iobs1 ) Do iobs2 = 1 , n2 ! loop over all data 1 & data 2 pairs t = real ( ti - t2 ( iobs2 ), Kind = SP ) If (( t - tlow ) * ( tup - t ) >= 0._SP ) Then If ( iscale == 1 ) t = Log10 ( t ) ! log scale ilag = Nint (( t - tlag0 ) / lstep ) + 1 If ( ilag > 0 . And . ilag <= nlag ) Then v = av2 - d2 ( iobs2 ) + vi v = v * v - ei - v2 ( iobs2 ) !   Use rounding proof algorithm for accumulation of means and variances cnt = lgs ( ilag ) + 1._SP oldaver = cc ( ilag ) aver = oldaver + ( v - oldaver ) / cnt cc ( ilag ) = aver cv ( ilag ) = cv ( ilag ) + ( v - oldaver ) * ( v - aver ) lgs ( ilag ) = cnt End If End If End Do End Do ! !   Get errors and time lag grid ! Do ilag = 1 , nlag If ( lgs ( ilag ) > 1.5_SP ) Then cv ( ilag ) = Sqrt ( cv ( ilag ) / ( lgs ( ilag ) - 1._SP )) If ( ifunct /= 1 ) cv ( ilag ) = var12 - cv ( ilag ) ! calculate CCF variance End If If ( ifunct /= 1 ) cc ( ilag ) = var12 - cc ( ilag ) ! calculate CCF lgs ( ilag ) = lag0 + lstep * ( ilag - 1 ) End Do End Subroutine covar1 ! Subroutine fouw ( t , valin , er , frin , nh2 , frout , valout , cof , & & dcof , nobs ) ! !! FOUW - Fit Fourier series (cof) and Return vector of residuals !!          (fout), adjusting frequency (fr) by NLSQ !! !!  Purpose: !!   Twofold: (i) Find Fourier coefficients and improve frequency !!   (ii) Pre-whiten data with a given frequency ! !!  Method: !!   Fits Fourier series of nh2/2 harmonics with frequency adjustment !!   NLSQ by Newton-Raphson iterations: !!   fin(ph)=cof(1)+sum_{n=1}&#94;{nh2/2}(cof(2n-1)Cos(ph*n)+cof(2n)*Sin(ph*n)) !!   where ph=2pi*frout*(t-t0) and t0=(max(t)+min(t))/2 !!  Input: !!   t(:),fin(:),er(:) -times, values and weights of observations; !!   nh2- number of model parameters: nh2/2-no. of harmonics !!   frin- initial value of frequency is abs(fr) !!       for frin<0 on Return frout=frin !!       for frin>0 value of frout is adjusted by NLSQ iterations !!  Output: !!   frout-final value of frequency (see frin) !!   cof(:),dcof(:)-Fourier coefficients and errors !!      cof(nh2+2)-approximate t0 (for full accuracy use t0=(max(t)+min(t))/2) !!      dcof(nh2+2)-frequency error (0 for fr<0) !! !!  Copyrights and Distribution: !!  This package is subject to copyrights by its author, !!  (C) A. Schwarzenberg-Czerny 1998-2011,  alex@camk.edu.pl !!  Please quote A.Schwarzenberg-Czerny, 1995, Astr. & Astroph. Suppl, 110,405 ; ! Integer , Parameter :: ITMAX = 100 !! max number of Newton-Raphson iterations Integer , Intent ( In ) :: nobs !! number of observations Real ( TIME ), Intent ( In ) :: t ( nobs ) !! observation times Real ( SP ), Intent ( In ) :: valin ( nobs ) !! observation values Real ( SP ), Intent ( In ) :: er ( nobs ) !! observation weights Integer , Intent ( In ) :: nh2 !! number of Fourier coef's (nh2=2*nh+1) Real ( TIME ), Intent ( In ) :: frin !! initial frequency approximmation Real ( TIME ), Intent ( Out ) :: frout !! improved frequency Real ( SP ), Intent ( Out ) :: valout ( nobs ) !! residuals from fit/prewhitened data Real ( SP ), Intent ( Out ) :: cof ( nh2 / 2 * 2 + 2 ) !!   Fourier coefficients Real ( SP ), Intent ( Out ) :: dcof ( nh2 / 2 * 2 + 2 ) !!   coefficient errors ! Logical :: finish Integer :: l , n , nn2 , nh , nx , nx1 , it Real ( SP ), Allocatable :: e (:), a (:, :) Real ( SP ) :: cond , detnth , rhs , sig , avstep Real ( TIME ) :: ph , t0 , dfr ! nh = Max ( 1 , nh2 / 2 ) nn2 = nh + nh ! ! If ( nobs < nh + nh + 2 . Or . size ( valin ) /= nobs . Or . size ( er ) /= nobs & . Or . size ( valout ) /= nobs ) Then Write ( * , * ) 'FOUW:error: wrong Size of arrays' Return End If ! t0 = ( maxval ( t ) + minval ( t )) * 0.5_TIME dfr = 1. / ( maxval ( t ) - minval ( t )) ! cof = 0._SP dcof = 0._SP frout = Abs ( frin ) Print * , '  it    sigma   step    cond' Do it = 1 , ITMAX nx = nn2 + 2 nx1 = nx ! adjust only coefficients If ( it > 1 ) nx1 = nx + 1 ! adjust also frequency Allocate ( e ( nx1 ), a ( nx1 , nx1 )) a = 0._SP ! Do l = 1 , nobs ph = frout * ( t ( l ) - t0 ) ph = PI2 * ( ph - floor ( ph )) * 0.5_SP rhs = valin ( l ) - cof ( 1 ) e = 0._SP e ( 1 ) = 1._SP ! Do n = 2 , nn2 , 2 e ( n ) = real ( Cos ( ph * n ), SP ) e ( n + 1 ) = real ( Sin ( ph * n ), SP ) e ( nx ) = e ( nx ) + ( - e ( n + 1 ) * cof ( n ) + e ( n ) * cof ( n + 1 )) * n rhs = rhs - e ( n ) * cof ( n ) - e ( n + 1 ) * cof ( n + 1 ) End Do ! e ( nx ) = e ( nx ) * real ( PI2 * 0.5_SP * ( t ( l ) - t0 ), SP ) e ( nx1 ) = rhs valout ( l ) = rhs If ( er ( l ) > 0._SP ) Then e = e / er ( l ) Call givensacc ( e , a ) End If End Do ! finish = ( frin < 0. . And . it >= 2 ) If ( . Not . finish ) Then cond = givens ( a , nobs - nx1 + 1 , detnth ) sig = Sqrt ( a ( nx1 , nx1 )) avstep = Sqrt ( sum ( a ( nx1 , : nx1 - 1 ) ** 2 ) / ( nx1 - 1 )) cof ( nx ) = 0._SP cof (: nx1 - 1 ) = cof (: nx1 - 1 ) + a ( nx1 , : nx1 - 1 ) frout = frout + cof ( nx ) Do l = 1 , nx1 - 1 dcof ( l ) = Sqrt ( Max ( a ( l , l ), tiny ( a ))) End Do finish = Abs ( cof ( nx )) > dfr . Or . Abs ( cof ( nx )) < dcof ( nx ) * 0.01 End If If ( Nint ( Exp ( Nint ( 2.5 * Log ( real ( it ))) / 2.5 )) == it . Or . finish ) & Print '(i5,f10.5,2(1pe8.1))' , it , sig , avstep , cond If ( finish ) Exit Deallocate ( e , a ) End Do cof ( nx ) = real ( t0 , SP ) ! Print * , 'frout=' , frout Do l = 1 , nx1 - 1 Print '(2(f10.5,a))' , cof ( l ), ' +/-' , dcof ( l ) End Do End Subroutine fouw ! End Module aovsub","tags":"","loc":"sourcefile/aovsub.f90.html"},{"title":"aov.f90 – Aov","text":"Contents Programs main Source Code aov.f90 Source Code Program main ! !! Purpose:<br> !!-------------------------------------------------------------------------<br> !!`Aov` is a tool for period analysis of irregularly sampled time series, !!such as stellar and planetary transit light curves. It relies on state-of-art !!statistically poweful, robust and fast algorithms implemented in !!my `AovPer` package, partly based on my original research and !!publications. All routines come in two flavours, with/without weights.<br> !!References:<br> !!--------------------------------------------------------------------------<br> !!The methods used are based on my 3 papers, listed in the !!corresponding routine headers:<br> !!aov-phase binning aov (Schwarzenberg-Czerny, A., 1989, MNRAS 241, 153);<br> !!aovmh-multi-harmonic aov (Schwarzenberg-Czerny, A., 1996, ApJ(Lett) 460L, 107);<br> !!aovtr-transit/eclipse aov (Schwarzenberg-Czerny, A. & Beaulieu, J.-Ph., !!2006, MNRAS 365, 165);<br> !!These papers and my software are also available from my web page !!`http://www.camk.edu.pl/~alex/`<br> !!Please cite this papers accordingly in publications using the current package.<br> !!Input:<br> !!--------------------------------------------------------------------------<br> !!Observations - one ASCII file per star, 2 or 3 columns in order: time,value,error<br> !!`aov.par` - file containing default values of program parameters<br> !!The file `aov.par` must exist, at least with dummy content `&par /`. !!Aov command line: may reset parameters from aov.par<br> !!Star name is either in STAR parameter or input from file named in STRLST. !!File of star observations is named DIR+STAR+EXT, where + marks concatenation.<br> !!Running `./aov STAR=SIMUL` generates sample input (see Usage). !!Compilation:<br> !!---------------------------------------------------------------------------<br> !!AOV is compiled simply by:<br> !!`gfortran -o aov aovconst.f90 aovsub.f90 aovprms.f90 aovobs.f90 aovspec.f90 aovper.f90 aov.f90`<br> !! !!For debugging/testing use:<br> !!`gfortran -g -Og -fimplicit-none -Wall -Wline-truncation -Wcharacter-truncation -Wsurprising -Waliasing -Wimplicit-interface -Wunu !!Usage:<br> !!-------------------------------------------------------------------------<br> !!Running `./aov` generates sample input parameter file `aov.par` and !!data file `SIMUL1.dat`. Then command `./aov STAR=SIMUL1` executes them in the !!ordinary way as if provided by the user.<br> !!Program Parameters: !!---------------------------------------------------------------------<br> !!Obligatory Parameters (listed either in aov.par or command line): !!`  character*(20)    :: STAR=\"\"!  star name or ...   `<br> !!`  character*(20)    :: STRLST=\"\"! name of file of star names  `<br> !!<br> !!Optional command parameters of main interest and their default values`<br> !!`  real(TIME)        :: FR0=0. !  lower frequency`<br> !!`  real(TIME)        :: FRU=4. !  upper frequency`<br> !!`  real(TIME)        :: FRS=0. !  frequency step (0.-optimum sampling)`<br> !!`                       !  warning: undersampling risk for FRS>0. `<br> !!`  integer           :: NPAR=5  ! number of model parameters`<br> !!`  integer           :: METHOD=AOVMH ! select from`<br> !!`                          ! AOV,AOVTR,AOVMH,AOVW,AOVTRW,AOVMHW`<br> !!`                          ! Those ending 'W' process weights.`<br> !!`  integer           :: NCOV=2 ! number of bin coverages`<br> !!`  character*(20)    :: DIR=''     ! Light curve file name prefix`<br> !!`  character*(20)    :: EXT='.dat' ! Light curve file name extension`<br> !!Full list is in header of `mprms` module.<br> ! !!Input parameter NPAR sets number of phase bins NPAR phase bins or !!NPAR/2 Fourier harmonics. !!I was using 3<=NPAR<=9 and I do not recommend exceeding these limits !!in general period surveys. For transient search use much higher values !!of NPAR, so that transit width ~1/NPAR. In theory, the CPU time !!is proportional to ~NPAR, but as NPAR increases the spectral !!resolution also increases, so it is advisable to decrease !!the frequency step by 1/NPAR (done automatically by the code), !!which causes CPU time scaling like ~NPAR&#94;2. There !!are possible additional CPU savings, but these are not !!worth worrying about at this stage. NPAR=5 worked well !!for near sinusoidal oscillations.<br> !!FSAMPL needs to be set =>3. The FSAMPL=4 choice means 4 frequencies covering !!a spectral line. This is in my opinion close to optimal as the code fits !!line profile to find peak frequency. If speed is no problem one can use e.g. FSAMPL=7.<br> !!The fastest are `AOV` or `AOVW`, depending on `ERRIN`, yet they !!suffer from an artificial noise/residuals due to sharp steps between phase bins. !!`AMH` and `AMHW` employ a smooth Fourier model hence are statistically better, yet !!about 10 times slower. All four algorithms complexity scales proportional !!to number of observations, frequencies and model parameters.<br> ! !!Methods:<br> !!------------------------------------------------------------------<br> !!The algorithms employ either bins and sub-bins or projection onto !!ortogonal polynomials yielding as fast implementation as possible when !!irregular sampling with large gaps make FFT impractical. !!Use of orthogonal functions, either phase binning or !!trigonometric polynomials results in statistically near optimal !!behaviour in that cross-talk/correlation between model elements is minimal. !!Because of that the algorithms remain fairly robust against outliers. !!More importantly use of orthogonal functions permits !!application of the classical Fisher AnoVa statistics to !!evaluate frequency spectrum and reliability of any detected periods. !!Depending on `SPTYPE` the spectrum obeys either !!Fisher-Snedecor F or beta probability distributions.<br> ! !!Experience:<br> !!-----------------------------------------------------------------<br> !!The original periodogram/frequency spectrum routines were used on !!over 10&#94;5 stars, as part of f95 TATRY package in OGLE and LCVSS !!mass photometry surveys and in EROS c package !!All Star Searcher, among others used to analyse 318 light curves !!of suspected variable stars in the field M31C. For the Cepheids !!and the eclipsing binaries. Tests against periods set by manual !!inspection of periodograms and light curves were performed !!on 25 000 light curves from ASAS South. The comparision involved the most !!significant periods only. The periods always !!agreed or were 2om or 3om or om/2 sub-/harmonics of the published frequency om. !!For Cepheids NPAR=5 worked well. For eclipsing binaries with proximity !!effects (e.g. W UMA) or for sinusoidal variables NPAR=3 was better, !!however 2om ambiguities occured.<br> !!Trials demonstrated that the aov detection criterion !!used in the present code works better than the Laefler-Kinman, !!PDM and Stetson criteria for eclipsing or pulsating variable stars. !!However, picking right NPAR for your problem requires some !!trial runs before decision on the final NPAR. For some applications, !!such as transit search it sis recommended to perform several runs, !!e.g. for NPAR=15, 30 and 60, to scan a range of transit widths.<br> ! !! History:<br> !!-------------------------------------------------------------------<br> !! 1989 - development of AOV phase binning routines;<br> !! 1996 - AOVMH Fourier series routines added;<br> !! 1999-2002 - all AOV routines expanded for use as module in TATRY code;<br> !! 2003 - porting of AOV routines into C for use in EROS and DIRECT projects. !! This resulted in major upgrade/factor several sppeding of the algorithm AOV by !! introduction of subbins;<br> !! 2004 - new transient search algorithm fitting top-hat/box function;<br> !! 2018 - subsstantial revision: main changes were in array declarations and !!normalization of observations. All fixed lengh arrays are replaced with the !!dynamic ones. In periodogram subroutines observations are now copied into local !!arrays when needed. Input observations are left intact. Small inconsistencies !!were removed and AOV and AOVTR routines were combined into one AOV routine !!performing both ordinary phase folding and binning or transit search. !!F95 and C packages became compatible to a high degree. Auto documentation using `ford`. !!Phases are now calculated in a uniform way using:<br> !!`dph=fr*t[i]`<br> !!`dph-=floor(dph)`<br> !!Tests on AMD PC and gcc demonstrated that `-=floor` is faster than `fmod`.<br> !! 2020 - improved handling of command line string parameters, introduction of !! optional list of star names.<br> !! !!Copyrights:<br> !!The whole package is subject to copyrights by its author, !!(C) A. Schwarzenberg-Czerny 1089-2020,  alex@camk.edu.pl !!It is free to use and copy, yet distribution of modiffications or fragments !!is forbidden. It is unsuitable for application carrying risk of damages. !!To acknowledge its use, pleas cite papers listed in the References section.<br> ! ! Use aovconst Use mprms Use aovper Use aovsub Use aovobs Use aovspec ! Implicit None ! ! Variables Logical :: simul , list Real ( SP ) :: dfm , thm , qual Integer :: ib , j , metcnt ! ! Real ( TIME ), Allocatable :: f (:), fb (:) Type ( SPEC_T ) :: spec Type ( OBS_T ) :: obs ! io = prog_args ( 'aov' ) If ( io /= 0 ) Then Print '(A)' , 'Usage:' , & './aov to generate sample .par and .dat files' , & './aov STAR=SIMUL1 to run those .par and .dat files' , & './aov  [[option=value]...] for general use' , & 'where option=FR0|FRU|FRS|NH2|METHOD|SPTYPE|NCOV|DIR|EXT|STAR' , & 'METHOD=aov|atr|amh|psp|aovw|atrw|amhw|pspw' , & 'SPTYPE=RAW|AOV|MODEL|RESID' , & 'EPOCH=MIN|AVE|MED|number' , & 'Option names are not case sensitive' , & 'Values must not contain ''='' sign' , & 'String values are case sensitive and bracket \"\" is needed' , & 'when they contain SPACE or special characters' , & 'File aov.par has f90 namelist format' , & 'Command line parameter values have precedence over aov.par' , & 'If STRLST=fname, star names are input from file fname' Stop End If NCOV = Max ( 1 , NCOV ) FRU = Max ( FR0 , FRU ) NPAR = Max ( 2 , NPAR ) NBEST = Max ( 1 , NBEST ) METHOD = toupper ( METHOD ) SPTYPE = toupper ( SPTYPE ) EPOCH = toupper ( EPOCH ) Allocate ( fb ( NBEST )) ! Print '(A)' , \"\" , & '  AOV/f90 Periodogram Routines, version ' // VER , & '  by (C) Alex Schwarzenberg-Czerny alex@camk.edu.pl' , \"\" Call print_args ( 6 ) Print * ! Open ( 3 , File = trim ( STRLST ), Status = 'old' , IoStat = io ) list = ( io == 0 ) If ( . Not . list . And . len_trim ( STRLST ) > 0 ) Then Print '(A)' , 'Failed to open STRLST=' // trim ( STRLST ), & 'Instead Tries STAR=' // trim ( STAR ) End If ! Get data ... Do If ( list ) Then Do Read ( 3 , '(A)' , IoStat = io ) STAR If ( io <= 0 ) Exit End Do If ( io < 0 ) Then Close ( 3 ) Exit End If End If ! simul = ( trim ( STAR ) == 'SIMUL' ) If ( simul ) Then ! ...from simulation obs = test_obs ( 100 ) ! also outputs simulated data to SIMUL1.dat) STAR = \"SIMUL1\" Open ( 4 , File = 'aov.par' , Status = 'unknown' ) Call print_args ( 4 ) Close ( 4 ) Else ! ... or from a file. NOTE: appends file prefix/extension, if any. msg = trim ( DIR ) // trim ( STAR ) // trim ( EXT ) obs = get_obs ( trim ( msg )) If ( obs % no <= 0 ) Then Print * , '***No valid data for STAR=' // trim ( STAR ) If ( list ) Cycle Exit End If End If ! Process data/observations If ( obs % no <= NPAR ) Then Print * , '***Too few observations, abandoning ' // trim ( STAR ) Else If ( minval ( obs % t ( 2 :) - obs % t (: obs % no - 1 )) < 0. ) & Print * , '***Warning: time not sorted in ' // trim ( STAR ) Print * , 'Are errors given? ' , obs % weights ! metcnt = 1 ! Set up frequency grid and get periodogram spec = fgrid ( obs % t , NPAR / 2 , FR0 , FRU , FRS ) Allocate ( f ( spec % nfr ), Stat = io ) If ( io /= 0 ) Then Print * , \"Failed memory allocation for f\" Cycle End If Forall ( j = 1 : spec % nfr ) f ( j ) = spec % FRS * ( j - 1 ) + spec % FR0 If (( obs % tmax - obs % tmin ) * spec % FRS > 0.3 . And . VERBOSE ) & Print * , \" AOV: warning: undersampling in frequency\" ! do imet=1,8 !    method=trim(meths(imet)) If ( metcnt == 1 ) & Print '(a,2g15.8,i8)' , 'grid: ' , spec % FR0 , spec % FRS , spec % nfr ! ! Calculate periodogramme io = aovdrv ( METHOD , SPTYPE , obs % t , obs % v , obs % w , NPAR , & NCOV , spec ) ! Write result periodogram into file Open ( 4 , File = trim ( STAR ) // trim ( METHOD ) // '.res' , Status = 'unknown' , & IoStat = io ) If ( io /= 0 ) Then Print * , 'Failed to open ' // trim ( STAR ) // '.res' Exit End If Write ( 4 , '(g15.8,f12.8)' ) ( f ( j ), Log10 ( spec % th ( j )), j = 1 , & & spec % nfr ) Close ( 4 ) ! Find & remove peaks Do ib = 1 , NBEST Call peakrm ( obs % tmax - obs % tmin , spec , fb ( ib ), thm , dfm ) If ( ib == 1 ) qual = Log10 ( thm ) End Do ! Print summary If ( metcnt == 1 ) & Print * , \"meth star  no_obs quality best_frequencies\" Print '(1x,a4,1x,a6,i5,f8.3,10f10.5)' , METHOD , trim ( STAR ), & obs % no , qual , ( fb ( ib ), ib = 1 , NBEST ) metcnt = metcnt + 1 ! end do Deallocate ( f ) Call clr_spec ( spec ) End If Call clr_obs ( obs ) If ( . Not . list ) Exit End Do ! Print * , 'AOV finished' Print * ! End Program main ! ! ! ! ! ! !","tags":"","loc":"sourcefile/aov.f90.html"},{"title":"aovspec.f90 – Aov","text":"Contents Modules aovspec Source Code aovspec.f90 Source Code Module aovspec !! Routines for handling frequency spectra. !! This file is part of AOV package of routines for computation and evaluation !! of periodograms. !! (C) A. Schwarzenberg-Czerny 1998-2018, alex@camk.edu.pl !! Its distribution is free, except that distribution of modifications is !! prohibited. ! Use aovconst Use mprms , Only : verbose , fsampl , mxfrq Use aovsub ! ! Implicit None ! Private Public fgrid , peak , peakrm , cre_spec , clr_spec ! Contains ! Function cre_spec ( nfr , fr0 , frs ) !! create structure for spectrum frequency grid Type ( SPEC_T ) :: cre_spec !! new spec structure Integer , Intent ( In ) :: nfr !! number of frequencies Real ( TIME ), Intent ( In ) :: fr0 !! initial frequency Real ( TIME ), Intent ( In ) :: frs !! frequency step ! cre_spec = SPEC_T ( nfr , fr0 , frs , NULL ()) Allocate ( cre_spec % th ( nfr )) If ( . Not . allocated ( cre_spec % th )) Then Print * , \"cre_spec: Failed memory allocation: th\" Stop End If End Function cre_spec ! Subroutine clr_spec ( spec ) !! clear structure for spectrum frequency grid Type ( SPEC_T ) :: spec !! spec structure to destroy Deallocate ( spec % th ) End Subroutine clr_spec ! Function fgrid ( t , npar , fr0in , fruin , frsin ) !! Purpose: !! Robust routine for evaluation of the time sampling pattern !! and guessing a suitable frequency grid. The spec structure containing !! grid parameters is returned as function value. ! ! !! (C) A. Schwarzenberg-Czerny 1998-2018, alex@camk.edu.pl !! Distribution of FGRID is free, except that distribution of modifications is !! prohibited. ! Type ( SPEC_T ) :: fgrid !! new spec structure !! spec.NFR, spec.FR0 and spec.FRS !! where NFR is calculated as (FRU-FR0)/FRS+1 Integer , Intent ( In ) :: npar !! number of model parameters (to refine frequency grid) Real ( TIME ), Intent ( In ) :: t (:) !! times Real ( TIME ), Intent ( In ) :: fr0in !! low frequency Real ( TIME ), Intent ( In ) :: frsin !! if positive set input grid values, though fru>=frs is forced; !!           otherwise they are calculated within routine. Real ( TIME ), Intent ( In ) :: fruin !! high frequency ! Integer :: ind ( size ( t )), no , nf Real ( SP ) :: d ( size ( t ) - 1 ) Real ( TIME ) :: t0 , fru , fr0 , frs ! no = size ( t ) fru = fruin frs = frsin fr0 = fr0in fru = Max ( fru , frs ) If ( frs <= 0._TIME ) Then t0 = ( t ( no ) + t ( 1 )) * 0.5_TIME Call sortx ( real ( t - t0 , SP ), ind ) frs = t ( ind ( 1 + Nint ( 0.93 * ( no - 1 )))) - t & & ( ind ( 1 + Nint ( 0.07 * ( no - 1 )))) frs = 1._TIME / ( frs * npar * fsampl ) If ( fru <= 0._TIME ) Then d = real ( t ( ind ( 2 :)) - t ( ind (: no - 1 )), SP ) Call sortx ( d , ind (: no - 1 )) fru = 1._TIME / d ( ind ( 1 + Nint ( 0.33 * ( no - 2 )))) End If End If fru = Max ( fru , fr0 ) nf = Nint (( fru - fr0 ) / frs ) + 1 If ( nf > mxfrq ) Then nf = mxfrq frs = ( fru - fr0 ) / ( nf - 1 ) Print '(A)' , & 'FGRID: *** DANGER *** Data spacing too fine or span too long for good' , & 'sampling of periodogramme. Brute solution to increase MXFRQ costs extra' , & 'execution time. You may choose to preset shorter or coarser frequency' , & 'grid by first loading shorter span data to choose a narrower frequency' , & 'range of interest and next load the big data. You may also choose to' , & 'modify the data: if high frequencies do not matter, data could be binned' , & 'into coarser time grid. Alternatively, you may split data into shorter' , & 'intervals and take average of several periodograms, thus keeping the' , & 'frequency range while degrading resolution. This kind of problems are' , & 'fundamental in time-frequency analysis independed of algorithm.' , & 'Violation of the uncertainity principle Dt*Df<1, where either' , & 'Dt-time span and Df-frequency resolution or Dt-resolution and Df-span' , & 'yields respectively undersampling or clipping of (effective) Nyquist' , & 'interval.' End If fgrid = cre_spec ( nf , fr0 , frs ) End Function fgrid ! Subroutine peak ( n , fx , xm , fm , dx ) !! Scan periodogram for a peak and return its properties<br> !! Method:<br> !! For `f=log(fx)` fits a parabola `0.5(d2*x**2+d1*x)+f(2)` !! where `d2=f(1)+f(3)-2f(2)`, `d1=f(3)-f(1)` !! finds `dxl` & `dxp` such, that the linear and quadratic terms drop !! by 0.7 in log, i.e. by a factor of 2 `(dx=HWHI)`.<br> !! (C) Alex Schwarzenberg-Czerny, 1999-2005 alex@camk.edu.pl ! Integer , Intent ( In ) :: n !! periodogram length Real ( SP ), Intent ( In ) :: fx ( n ) !! periodogram values Real ( TIME ), Intent ( Out ) :: xm !! peak location (in index units, 1<xm<n) Real ( SP ), Intent ( Out ) :: fm !! peak value; Real ( SP ), Intent ( Out ) :: dx !! peak halfwidth HWHI,dx<0 no valid peak ! Integer :: nm , n0 Real ( SP ) :: f ( 3 ), d2 , d1 ! ! valid maximum? nm = maxloc ( fx , dim = 1 ) fm = fx ( nm ) xm = real ( nm , TIME ) dx = - 1. If ( fm < 0. ) Return ! linear case (peak at edge) n0 = Max ( 2 , Min ( n - 1 , nm )) f = Log ( Max ( Abs ( fx ( n0 - 1 : n0 + 1 )) / fm , epsilon ( 1._SP ))) d1 = f ( 3 ) - f ( 1 ) dx = - Abs ( d1 ) / 1.4 ! ! parabolic case (not on edge) d2 = - ( f ( 1 ) - f ( 2 ) - f ( 2 ) + f ( 3 )) If ( d2 > 0.7 * dx * dx ) Then ! original 1.4 fm = Exp ( 0.125 * d1 * d1 / d2 + f ( 2 )) * fm xm = 0.5 * d1 / d2 + n0 dx = Sqrt ( 0.7 * d2 ) End If dx = 1. / dx End Subroutine peak ! Subroutine peakrm ( dt , spec , freq , thm , dfm ) !! Finds a peak and flags it to search for subsequent ones. !! Flags are negated weights, so they are not lost. Real ( TIME ), Intent ( In ) :: dt !! peak width Type ( SPEC_T ) :: spec !! spectrum structure (changed on output) Real ( SP ), Intent ( Out ) :: thm !! current peak value Real ( SP ), Intent ( Out ) :: dfm !! current peak width Real ( TIME ), Intent ( Out ) :: freq !! current peak frequency ! Integer :: iwdt , nfm , j ! ! find peak Call peak ( spec % nfr , spec % th , freq , thm , dfm ) dfm = dfm * real ( spec % frs , SP ) nfm = Nint ( freq ) freq = ( freq - 1 ) * spec % frs + spec % fr0 iwdt = Int ( 1.7 / Abs ( dt * spec % frs )) + 1 ! remove peak +-iwdt Forall ( j = Max ( 1 , nfm - iwdt ) : Min ( spec % nfr , nfm + iwdt )) & spec % th ( j ) = - Abs ( spec % th ( j )) End Subroutine peakrm ! End Module aovspec","tags":"","loc":"sourcefile/aovspec.f90.html"},{"title":"aovprms.f90 – Aov","text":"Contents Modules mprms Source Code aovprms.f90 Source Code ! Module mprms !! Purpose: <br> !! Module demonstrates reading f90 program global arguments from parameter file !! and/or command line. <br> !! Implementation: <br> !! In the present module as global variables declare and set default values !! to all code parameters. To reset them from parameter file and/or command line !! in the Main program call once subroutine ``prog_args`` from this module. !! All modules may access these values via ``Use mparam`` declaration. !! You may use ``Only`` phrase to restrict access/prevent confusion with !! local variables. To make code clearer you may capitalize parameters though !! it has no impact on the compiler so name variables with care.<br> !! Operation:<br> !! The initial declared values are overwritten subsequently by those present !! in the parameter file and command line. Syntax rules follow those of f90 !! NAMELIST file. Note insensitivity to capitalization and order and !! use of both space and comma as delimiters. !! Parameter lists including strings must be enclosed with !! yet another pair of string marks (see examples).<br> !! History:<br> !! Based on an example Namelist use by John S. Urban, 2009<br> !! http://www.urbanjost.altervista.org/LIBRARY/libGPF/arguments/namelist/index.html<br> !! (C) alex schwarzenberg-czerny, 2018, alex@camk.edu.pl<br> ! !! Example parameter file prog_args.par:<br> !! &par OTHER_INTEGER=2 / <br> ! !! Example calls:<br> !! ./t SOME_LOGICAL=T some_real=200e3  OTHER_INTEGER=200 <br> !! ./t \"SOME_STRING='my character string' SOME_INTEGER=10,SOME_REAL=20.30\" <br> !! ./t other_INTEGER=33333, SOME_INTEGER=22222 <br> Use aovconst Use aovsub Implicit None ! ! Declare and initialize a NAMELIST of program global parameters ! Capitalizing prevents confusion with local variables Logical :: VERBOSE = . False . !! Printout control Logical :: ERRIN = . False . !! Error column present? Integer :: NBEST = 5 !! Number of best frequencies Integer :: CTMIN = 5 !! minimum bin occupancy Real ( SP ) :: FSAMPL = 7._SP !! oversampling factor Real ( TIME ) :: FR0 = 0. !!  lower frequency Real ( TIME ) :: FRU = 4. !!  upper frequency Real ( TIME ) :: FRS = 0. !!  frequency step (0.-optimum sampling) !!  warning: undersampling risk for FRS>0. Integer :: MXFRQ = 1000000 !! max number of frequencies Integer :: NPAR = 5 !! number of model parameters Integer :: NCOV = 2 !! number of bin coverages Character ( Len = 4 ), Parameter :: meths ( 8 ) = & ( / 'AOV ' , 'ATR ' , 'AMH ' , 'PWS ' , 'AOVW' , 'ATRW' , 'AMHW' , 'PWSW' / ) Character ( Len = 4 ) :: METHOD = 'AMH' !! select from !! AOV,ATR,AMH,PWS,AOVW,ATRW,AMHW,PWSW Character ( Len = 5 ) :: SPTYPE = 'AOV' !! select from !! RAW,AOV,MODEL,RESID Character ( Len = LSTRING ) :: DIR = '' !! LC file name prefix Character ( Len = LSTRING ) :: EXT = '.dat' !! LC file name extension !! obligatory command parameter (no keyword, order matters) Character ( Len = LSTRING ) :: STAR = 'SIMUL' !!  star name; !! `STAR='SIMUL'` supplies for calculation simulated test data Character ( Len = LSTRING ) :: STRLST = '' !!  star list file name; !! If non-empty it replaces STAR as source of star names Character ( Len = LSTRING ) :: EPOCH = 'AVE' !! epoch type: `MIN` of times, `AVE` -average, `MED` -median or else !! number  given in EPOCH. ! !! ... just add more variable declaration here and append them to NAMELIST Namelist / par / VERBOSE , NBEST , ERRIN , CTMIN , FSAMPL , FR0 , FRU , & FRS , MXFRQ , NPAR , NCOV , METHOD , SPTYPE , DIR , EXT , STAR , STRLST , & EPOCH Contains ! Function prog_args ( pname ) !! Inputs arguments succesively from parameter file and command line !! and resets module NAMELIST global variables, if present in input, !! as an intended side effect. par and NAMELIST variables are external. Integer :: prog_args !! status Character ( Len =* ), Intent ( In ) :: pname !! name of parameter file ! Character ( Len = 255 ) :: string Integer :: io , j Do ! dummy loop to use exit statements ! get parameter file arguments string = trim ( pname ) // '.par' Open ( 2 , File = string , Status = 'old' , IoStat = io ) If ( io == 0 ) Then Read ( 2 , Nml = par , IoStat = io ) If ( io /= 0 ) Print * , 'Parameter file syntax error' Close ( 2 ) Else Print * , 'No parameter file ' // trim ( string ) // ' found' End If ! get command line arguments string = '' io = 1 Do ! get_command_argument trips string brackets \"\"'' Call get_command_argument ( io , msg ) If ( LEN_TRIM ( msg ) == 0 ) Exit j = index ( msg , '=' ) Select Case ( toupper ( msg ( 1 : j - 1 ))) ! adds string brackets when needed Case ( 'METHOD' , 'SPTYPE' , 'DIR' , 'EXT' , 'STAR' , 'STRLST' , 'EPOCH' ) string = trim ( string ) // ' ' // msg ( 1 : j ) // '\"' // & trim ( msg ( j + 1 :)) // '\"' Case Default string = trim ( string ) // ' ' // msg ( 1 : j ) // trim ( msg ( j + 1 :)) End Select io = io + 1 End Do string = \"&par \" // trim ( string ) // \" /\" Read ( string , Nml = par , IoStat = io ) ! internal read of NAMELIST If ( io /= 0 ) Print * , 'Commad line syntax error' Exit End Do If ( io . Ne . 0 ) Print * , 'error: ' , io !         Write (*, Nml=par)                  ! use the values prog_args = io End Function prog_args Subroutine print_args ( logunit ) Integer , Intent ( In ) :: logunit Write ( logunit , Nml = par ) End Subroutine print_args End Module mprms ! !","tags":"","loc":"sourcefile/aovprms.f90.html"},{"title":"aovobs.f90 – Aov","text":"Contents Modules aovobs Source Code aovobs.f90 Source Code Module aovobs !!   Routines for pre-processing of observations. !!   This is part of the AOV package of routines for computation and !!   evaluation of AOV periodograms. !!   This package is subject to copyrights by its author, !!   (C) A. Schwarzenberg-Czerny 1998-2018,  alex@camk.edu.pl !!   Its distribution is free, except that distribution of modifications is !!   prohibited. ! Use aovconst Use mprms , Only : epoch , verbose Use aovsub ! ! Implicit None ! Private Public get_obs , test_obs , clr_obs ! Contains ! Function cre_obs ( no , weights ) !! create structure for observations Type ( OBS_T ) :: cre_obs !! new obs structure Integer , Intent ( In ) :: no !! number of observations Logical , Intent ( In ) :: weights !! weights present? cre_obs % no = no Allocate ( cre_obs % t ( no ), cre_obs % v ( no )) If ( weights ) allocate ( cre_obs % w ( no )) End Function cre_obs ! Subroutine clr_obs ( obs ) !! clear structure for observations Type ( OBS_T ) :: obs !! obs structure to destroy If ( allocated ( obs % w )) deallocate ( obs % w ) If ( allocated ( obs % v )) deallocate ( obs % v ) If ( allocated ( obs % t )) deallocate ( obs % t ) End Subroutine clr_obs ! Function get_obs ( fname ) !! Purpose: !! Reads 2 or 3 ascii columns of observations from file fname. !! Returns structure obs storing them. Number of columns is set !! basing on first line containing 2 or 3 float numbers. Lines !! inconsistent with the first one are skipped. Character ( Len =* ), Intent ( In ) :: fname !! Input file name Type ( OBS_T ) :: get_obs !! result obs structure ! Type NODE_T Real ( TIME ) :: t Real ( SP ) :: v , w Type ( NODE_T ), Pointer :: next => NULL () End Type NODE_T Type ( NODE_T ), Pointer :: cur , sav , first Integer :: io , num , cnt , cols , skip Character ( Len = 80 ) :: buffer ! get_obs % no = 0 ! cnt = 0 cols = 0 skip = 0 Open ( 1 , File = trim ( fname ), Status = 'old' , IoStat = io ) ! get file If ( io /= 0 ) Then Print * , \"***get_obs: Failed to open \" // trim ( fname ) Return End If ! Allocate ( cur ) first => cur ! Do ! read one line and add to list Read ( 1 , '(A)' , IoStat = io ) buffer If ( io /= 0 ) Exit num = 3 Read ( buffer , * , IoStat = io ) cur % t , cur % v , cur % w If ( io /= 0 ) Then num = 2 Read ( buffer , * , IoStat = io ) cur % t , cur % v cur % w = 1._SP If ( io /= 0 ) num = 0 End If If ( num > 0 ) Then If ( cnt == 0 . And . num >= 2 . And . num <= 3 ) cols = num If ( num == cols ) Then cnt = cnt + 1 Allocate ( sav ) cur % next => sav cur => sav Else skip = skip + 1 End If Else skip = skip + 1 End If End Do Close ( 1 ) If ( verbose ) Print * , \"Accepted \" , cnt , \", Skipped \" , skip ! copy observations from list into arrays get_obs = cre_obs ( cnt , . True .) If ( get_obs % no <= 0 ) Return get_obs % weights = ( cols == 3 ) cur => first cnt = 1 Do If ( . Not . associated ( cur % next )) Exit get_obs % t ( cnt ) = cur % t get_obs % v ( cnt ) = cur % v get_obs % w ( cnt ) = cur % w cnt = cnt + 1 sav => cur cur => cur % next Deallocate ( sav ) End Do Deallocate ( cur ) ! normalize times and weights ! For numerical reasons subtract epoch from times Call norm_times ( epoch , get_obs ) Where ( get_obs % w /= 0._SP ) get_obs % w = 1._SP / & ( Abs ( get_obs % w ) * get_obs % w ) End Function get_obs ! Subroutine norm_times ( epstr , obs ) !! Purpose: <br> !! Normalize times prior period analysis. Depending on EPSTR and !! presence of weights calculates EPOCH and subtracts it from !! all times. This should be done for numerical reasons so that !! times span zero. Since user may wish a fixed epoch, e.g. to !! use consistent phase bins, this is not performed inside !! periodogram routines. Character ( Len =* ), Intent ( In ) :: epstr !! epoch string !! permitted: 'MIN','AVE','MED' or real number string Type ( OBS_T ) :: obs !! times modified by subtraction of EPOCH ! Integer :: ind ( obs % no ) Real ( TIME ) :: epval ! Call sortx ( obs % t , ind ) obs % tmin = obs % t ( ind ( 1 )) obs % tmax = obs % t ( ind ( obs % no )) Read ( epstr , * , IoStat = io ) epval If ( io /= 0 ) Then Select Case ( trim ( epstr )) Case ( 'MIN' ) epval = obs % tmin Case ( 'AVE' ) epval = sum ( obs % t * obs % w , mask = obs % w > 0._SP ) / sum & & ( obs % w , mask = obs % w > 0._SP ) Case ( 'MED' ) epval = obs % t ( ind (( obs % no + 1 ) / 2 )) Case Default If ( verbose ) Print * , \"norm_times: warning: wrong EPOCH string\" epval = obs % tmin End Select ElseIf (( epval - obs % tmin ) * ( epval - obs % tmax ) > 0._TIME . And . verbose ) Then Print * , \"norm_times: warning: EPOCH out of times range\" End If If ( verbose ) Print * , \"EPOCH= \" , obs % epoch obs % epoch = epval obs % t = obs % t - epval If ( any ( obs % t ( 2 :) - obs % t (: obs % no - 1 ) < 0._TIME ) . And . verbose ) & Print * , \"norm_times: warning: times not sorted\" End Subroutine norm_times ! Function test_obs ( no ) !! Returns simulated light curve for test purposes. Type ( OBS_T ) :: test_obs !! result structure containing observations Integer , Intent ( In ) :: no !! number of observations to simulate ! Integer , Allocatable :: ind (:) Integer :: k , k1 Real ( SP ) :: s2n , span , omt Real ( TIME ) :: fr , dph ! test_obs = cre_obs ( no , . True .) !   simulate data s2n = 10 0._SP span = 4 0._SP fr = 1._TIME / 0.3617869_TIME Print * , 'Simulated data, FR0=' , fr Do k = 1 , no k1 = k - 1 test_obs % w ( k ) = 0.5_SP test_obs % t ( k ) = span * Sin ( k1 * 1._TIME ) ** 2. test_obs % t ( 1 ) = 0._TIME test_obs % t ( no ) = span dph = fr * test_obs % t ( k ) omt = real ( PI2 * ( dph - floor ( dph )), SP ) test_obs % v ( k ) = 1 1.90_SP + 0.434_SP * Cos ( omt + 4.72_SP ) + & 0.237_SP * Cos ( 2._SP * omt + 0.741_SP ) + Sin ( k1 * 1.7_SP ) / s2n End Do test_obs % weights = . True . ! Open ( 4 , File = 'SIMUL1.dat' , Status = 'unknown' , IoStat = io ) If ( io /= 0 ) Then Write ( * , * ) 'Failed to write SIMUL1.dat' Stop End If ! Allocate ( ind ( no )) Call sortx ( real ( test_obs % t - test_obs % t ( 1 ), kind = SP ), ind ) Write ( 4 , '(f12.6,f13.6,f11.6)' ) ( test_obs % t ( ind ( k )), & test_obs % v ( ind ( k )), 1._SP / Sqrt ( test_obs % w ( ind ( k ))), k = 1 , no ) Close ( 4 ) Deallocate ( ind ) ! For numerical reasons subtract epoch from times Call norm_times ( epoch , test_obs ) ! End Function test_obs ! End Module aovobs","tags":"","loc":"sourcefile/aovobs.f90.html"},{"title":"aovconst.f90 – Aov","text":"Contents Modules aovconst Source Code aovconst.f90 Source Code Module aovconst ! !!AovConst.f90 : global definitions for Aov.f90 Implicit None ! ! parameters fixed at compile time ! Character ( Len =* ), Parameter :: VER = '25.04.2020' !! version Integer , Parameter :: SP = Kind ( 1 e0 ) !! type of measurements and errors Integer , Parameter :: CP = Kind (( 1._SP , 1._SP )) !! type of complex values Integer , Parameter :: TIME = Kind ( 1 d0 ) !! type of time & frequency variables Integer , Parameter :: LSTRING = 40 !! max input string length ! Real ( SP ), Parameter :: PI2 = 6.283185307179586476925286766559005768394_SP ! Type SPEC_T !! Spectrum structure Integer :: nfr !! number of frequencies Real ( TIME ) :: fr0 !! lowest frequency Real ( TIME ) :: frs !! frequency increment Real ( SP ), Allocatable :: th (:) !! frequency spectrum/periodogram End Type SPEC_T Type OBS_T !! Observations structure Integer :: no = 0 !! number of observations Logical :: weights = . False . !! Weights present? Real ( TIME ) :: epoch = 0._TIME !! Epoch Real ( TIME ) :: tmin = 0._TIME !! Min time Real ( TIME ) :: tmax = 0._TIME !! Max time Real ( TIME ), Allocatable :: t (:) Real ( SP ), Allocatable :: v (:), w (:) End Type OBS_T Character ( Len = 80 ) :: msg !! a string variable of local use Integer :: io !! a status variable of local use End Module aovconst","tags":"","loc":"sourcefile/aovconst.f90.html"},{"title":"SPEC_T – Aov ","text":"type, public :: SPEC_T Spectrum structure Contents Variables nfr fr0 frs th Components Type Visibility Attributes Name Initial integer, public :: nfr number of frequencies real(kind=TIME), public :: fr0 lowest frequency real(kind=TIME), public :: frs frequency increment real(kind=SP), public, Allocatable :: th (:) frequency spectrum/periodogram","tags":"","loc":"type/spec_t.html"},{"title":"OBS_T – Aov ","text":"type, public :: OBS_T Observations structure Contents Variables no weights epoch tmin tmax t v w Components Type Visibility Attributes Name Initial integer, public :: no = 0 number of observations logical, public :: weights = .False. Weights present? real(kind=TIME), public :: epoch = 0._TIME Epoch real(kind=TIME), public :: tmin = 0._TIME Min time real(kind=TIME), public :: tmax = 0._TIME Max time real(kind=TIME), public, Allocatable :: t (:) real(kind=SP), public, Allocatable :: v (:) real(kind=SP), public, Allocatable :: w (:)","tags":"","loc":"type/obs_t.html"},{"title":"aovdrv – Aov","text":"public function aovdrv(method, sptype, t, v, w, npar, ncov, spec) AOVDRV driver routine for AovPer frequency spectrum routines\n Purpose: example calling of spectrum routines. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: method periodogram method character(len=*), intent(in) :: sptype type of returned spectrum real(kind=TIME), intent(in) :: t (:) times real(kind=SP), intent(in) :: v (:) values real(kind=SP), intent(in) :: w (:) weights or errors, depending on ERRIN integer, intent(in) :: npar number of parameters integer, intent(in) :: ncov number of phase coverages type(SPEC_T) :: spec frequency grid and result spectrum Return Value integer status Contents None","tags":"","loc":"proc/aovdrv.html"},{"title":"dict_val – Aov","text":"public function dict_val(dict, isize, key) Find key position in a keyword dictionary.\n Restriction: dictionary entries are of equal size,\n all kept in one string. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: dict Dictionary string integer, intent(in) :: isize size of keys character(len=*), intent(in) :: key key string Return Value integer Key position Contents None","tags":"","loc":"proc/dict_val.html"},{"title":"tolower – Aov","text":"public function tolower(str) Change string case to lower Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: str input string Return Value character(len=Len(str)) result output string Contents None","tags":"","loc":"proc/tolower.html"},{"title":"toupper – Aov","text":"public function toupper(str) Change string case to upper Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: str input string Return Value character(len=Len(str)) result output string Contents None","tags":"","loc":"proc/toupper.html"},{"title":"givens – Aov","text":"public function givens(r, idf, detnth) overdetermined linear system by accurate Givens rotations.\n Prior to GIVENS call m-times GIVENSA in order to build the\n triangle system R\n (C) Alex Schwarzenberg-Czerny,2000      alex@camk.edu.pl Arguments Type Intent Optional Attributes Name real(kind=SP), intent(inout) :: r (:,:) r(n1,:)   - unknowns\n (r(k,k),k=1,n) variances\n (r(:k,k),k=1,n) half of covariance matrix\n (r(k+1:,k),k=2,n) half of inverse triangle root Q\n r(n1,n1) - chi&#94;2/idf (=RHS variance=std.dev&#94;2)\n         For idf<0:\n ((r(j,k),j=1,k),k=1,n) inverse triangle root  Q integer, intent(in) :: idf idf - >0 solve normal equations for idf degrees of freedom\n       <0 and r(n1,n1)=1: inverse triangle matrix R real(kind=SP), intent(out) :: detnth =Det(R)&#94;(1/n) - n-th root of determinant Return Value real(kind=SP) result condition ratio (min eigenv/max eigenv),\n 0 signalls singular system Contents None","tags":"","loc":"proc/givens.html"},{"title":"givensacc – Aov","text":"public subroutine givensacc(a, r) overdetermined linear system by Givens rotations, a state-of-art\n algorithm. Routine takes current observation equation from a and\n accumulates it into r:\n (C) Alex Schwarzenberg-Czerny,2000      alex@camk.edu.pl Arguments Type Intent Optional Attributes Name real(kind=SP), intent(in) :: a (:) a(n1)    - an equation with its RHS as a(n1) element,\n            multiplied by sqrt of weight.\n            Note: sum of all weights must equall no.observations,\n            lest GIVENS returns wrong covariance estimates. real(kind=SP), intent(inout) :: r (:,:) Contents None","tags":"","loc":"proc/givensacc.html"},{"title":"sortx – Aov","text":"public interface sortx Contents Module Procedures sortx_m_r4 sortx_m_r8 Module Procedures private subroutine sortx_m_r4(dat, ina) (C) Alex Schwarzenberg-Czerny, 2005      alex@camk.edu.pl\n Stable index sorting by merge sort. Requires extra memory (inb) Arguments Type Intent Optional Attributes Name real(kind=4), intent(in) :: dat (:) unsorted data integer, intent(out) :: ina (:) sort index private subroutine sortx_m_r8(dat, ina) (C) Alex Schwarzenberg-Czerny, 2005      alex@camk.edu.pl\n Stable index sorting by merge sort. Requires extra memory (inb) Arguments Type Intent Optional Attributes Name real(kind=8), intent(in) :: dat (:) unsorted data integer, intent(out) :: ina (:) sort index","tags":"","loc":"interface/sortx.html"},{"title":"cre_spec – Aov","text":"public function cre_spec(nfr, fr0, frs) create structure for spectrum frequency grid Arguments Type Intent Optional Attributes Name integer, intent(in) :: nfr number of frequencies real(kind=TIME), intent(in) :: fr0 initial frequency real(kind=TIME), intent(in) :: frs frequency step Return Value type(SPEC_T) new spec structure Contents None","tags":"","loc":"proc/cre_spec.html"},{"title":"fgrid – Aov","text":"public function fgrid(t, npar, fr0in, fruin, frsin) Robust routine for evaluation of the time sampling pattern\n and guessing a suitable frequency grid. The spec structure containing\n grid parameters is returned as function value. (C) A. Schwarzenberg-Czerny 1998-2018, alex@camk.edu.pl\n Distribution of FGRID is free, except that distribution of modifications is\n prohibited. Arguments Type Intent Optional Attributes Name real(kind=TIME), intent(in) :: t (:) times integer, intent(in) :: npar number of model parameters (to refine frequency grid) real(kind=TIME), intent(in) :: fr0in low frequency real(kind=TIME), intent(in) :: fruin high frequency real(kind=TIME), intent(in) :: frsin if positive set input grid values, though fru>=frs is forced;\n           otherwise they are calculated within routine. Return Value type(SPEC_T) new spec structure\n spec.NFR, spec.FR0 and spec.FRS\n where NFR is calculated as (FRU-FR0)/FRS+1 Contents None","tags":"","loc":"proc/fgrid.html"},{"title":"clr_spec – Aov","text":"public subroutine clr_spec(spec) clear structure for spectrum frequency grid Arguments Type Intent Optional Attributes Name type(SPEC_T) :: spec spec structure to destroy Contents None","tags":"","loc":"proc/clr_spec.html"},{"title":"peak – Aov","text":"public subroutine peak(n, fx, xm, fm, dx) Scan periodogram for a peak and return its properties Method: For f=log(fx) fits a parabola 0.5(d2*x**2+d1*x)+f(2) where d2=f(1)+f(3)-2f(2) , d1=f(3)-f(1) finds dxl & dxp such, that the linear and quadratic terms drop\n by 0.7 in log, i.e. by a factor of 2 (dx=HWHI) . (C) Alex Schwarzenberg-Czerny, 1999-2005 alex@camk.edu.pl Arguments Type Intent Optional Attributes Name integer, intent(in) :: n periodogram length real(kind=SP), intent(in) :: fx (n) periodogram values real(kind=TIME), intent(out) :: xm peak location (in index units, 1<xm<n) real(kind=SP), intent(out) :: fm peak value; real(kind=SP), intent(out) :: dx peak halfwidth HWHI,dx<0 no valid peak Contents None","tags":"","loc":"proc/peak.html"},{"title":"peakrm – Aov","text":"public subroutine peakrm(dt, spec, freq, thm, dfm) Finds a peak and flags it to search for subsequent ones.\n Flags are negated weights, so they are not lost. Arguments Type Intent Optional Attributes Name real(kind=TIME), intent(in) :: dt peak width type(SPEC_T) :: spec spectrum structure (changed on output) real(kind=TIME), intent(out) :: freq current peak frequency real(kind=SP), intent(out) :: thm current peak value real(kind=SP), intent(out) :: dfm current peak width Contents None","tags":"","loc":"proc/peakrm.html"},{"title":"prog_args – Aov","text":"public function prog_args(pname) Inputs arguments succesively from parameter file and command line\n and resets module NAMELIST global variables, if present in input,\n as an intended side effect. par and NAMELIST variables are external. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: pname name of parameter file Return Value integer status Contents None","tags":"","loc":"proc/prog_args.html"},{"title":"print_args – Aov","text":"public subroutine print_args(logunit) Arguments Type Intent Optional Attributes Name integer, intent(in) :: logunit Contents None","tags":"","loc":"proc/print_args.html"},{"title":"get_obs – Aov","text":"public function get_obs(fname) Reads 2 or 3 ascii columns of observations from file fname.\n Returns structure obs storing them. Number of columns is set\n basing on first line containing 2 or 3 float numbers. Lines\n inconsistent with the first one are skipped. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: fname Input file name Return Value type(OBS_T) result obs structure Contents None","tags":"","loc":"proc/get_obs.html"},{"title":"test_obs – Aov","text":"public function test_obs(no) Returns simulated light curve for test purposes. Arguments Type Intent Optional Attributes Name integer, intent(in) :: no number of observations to simulate Return Value type(OBS_T) result structure containing observations Contents None","tags":"","loc":"proc/test_obs.html"},{"title":"clr_obs – Aov","text":"public subroutine clr_obs(obs) clear structure for observations Arguments Type Intent Optional Attributes Name type(OBS_T) :: obs obs structure to destroy Contents None","tags":"","loc":"proc/clr_obs.html"},{"title":"aovper – Aov","text":"State-of-art routines for period search in unevenly sampled time series.\n  Package contains routines for phase folding and binning, Fourier series fit\n  power spectrum and search of planetary transits, for weighted and unweighted\n  observations. Calling: Demo calling example is contained in AovDrv routine in this file.\n  Because of numerical considerations times of observations need to be shifted\n  by subtraction of EPOCH time so that they span 0. This is not done within aovper routines to enable the user use of one value of EPOCH for\n  independent runs. All routines  come in two flavours: for\n  weighted and unweighted observations. Their calling sequences are uniform,\n  though depending on routine some parameters are ignored. CHAR sptype - determines type of frequency spectrum returned from routine;\n        for RAW , AOV , MODEL , RESID the spectrum obeys:\n        none, F, beta and another beta probability distributions INT no - number of observations TIMES t(No) - times of observations FLOAT v(no) - values of observations FLOAT w(no) - weights of observations INT npar - input number of parameters of mathematical model in use; INT ncov - input number of different phase origins employed to smooth\n       effects of time discretization SPEC_T spec - on input contains spectrum array th(no) and parameters of its\n  frequency grid nfr , fr0 , frs ,  where freq=ifr*frs+fr0, ifr=0,...,nfr-1 ;\n       on output th contains resultant frequency spectrum. Methods: The Aov package contains routines for period search and\n  planetary transit search by phase folding and binning of light curves\n  and/or by multi-harmonic Fourier series fit. For a particular set up\n  these routines reproduce popular box-least squares and generalised Lomb\n  Scargle algorithm, ableit in a more efficient implementations involving sub bins\n  or orthogonal projections. The period routines split into two groups:\n  (i) AOV/TR & AOVMH calculate quadratic norm of a fitted model.\n  As such their results obey Parceval theorem. Depending on SPTYPE parameter\n  the result spectrum may be converted to classical statistics: either aov\n  (Fisher F) spectrum or the corresponding beta statistics spectra of normalized\n  'model power' or 'residual chi2' flavour. (i.A) AOV/TR : Depending on sign of npar: for npar>0 aov/tr routine fits\n  folded light curve with a histogram of npar bins, for npar<0 aov/tr routine\n  fits light curve with just two phase bins: in- and out-of suspect transit.\n  The transit width is fixed by npar while its position is fine-tuned\n  depending on ncov . (Reference: A.Schwarzenberg-Czerny, 1989, MNRAS 241, 153;\n  A.Schwarzenberg-Czerny, & J.-Ph. Beaulieu,  2006, MNRAS 365, 165. (i.B) AOVMH fits Fourier series of npar terms by orthogonal projection on\n  Szego polynomials. Reference: A.Schwarzenberg-Czerny, 1996, ApJ 460L, 107.\n  In particular for npar=3 AOVMH returns Generalised\n  Lomb-Scargle spectrum of Ferraz-Mello, 1981 and Zechmeister & Kurster, 2009. (ii) The other two routines, PWSP & PWSPW , return squared amplitude of a fitted\n  sinusoid. The underlying algorithms differ from each other even for unary\n  weights. For uneven sampling the result power spectra obey no Parceval theorem\n  hence power spectra obey no classical probability distribution. Provided all\n  input values are 1 PWSP returns window function ( PWSPW does not). Several general utility routines are provided: GRID , PEAK and PEAKRM to set up frequency spectrum and analyse its peaks. NORM_TIMES from module AovObs may be used to subtract EPOCH from times. Copyrights: This package is subject to copyrights by its author,\n  (C) A. Schwarzenberg-Czerny 1998-2018, alex@camk.edu.pl\n  Its distribution is free, except that distribution of modifications is\n  prohibited. Please acknowlege use by citation of papers listed in the\n  corresponding routines. Uses aovconst mprms aovsub aovobs Contents Functions aovdrv Functions public function aovdrv (method, sptype, t, v, w, npar, ncov, spec) AOVDRV driver routine for AovPer frequency spectrum routines\n Purpose: example calling of spectrum routines. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: method periodogram method character(len=*), intent(in) :: sptype type of returned spectrum real(kind=TIME), intent(in) :: t (:) times real(kind=SP), intent(in) :: v (:) values real(kind=SP), intent(in) :: w (:) weights or errors, depending on ERRIN integer, intent(in) :: npar number of parameters integer, intent(in) :: ncov number of phase coverages type(SPEC_T) :: spec frequency grid and result spectrum Return Value integer status","tags":"","loc":"module/aovper.html"},{"title":"aovsub – Aov","text":"Utility routines for Aov. Note that only public routines are reliable and tested.\n Other ones are kept here for past/future development. Uses aovconst Contents Interfaces sortx Functions dict_val tolower toupper givens Subroutines givensacc Interfaces public interface sortx private subroutine sortx_m_r4(dat, ina) (C) Alex Schwarzenberg-Czerny, 2005      alex@camk.edu.pl\n Stable index sorting by merge sort. Requires extra memory (inb) Arguments Type Intent Optional Attributes Name real(kind=4), intent(in) :: dat (:) unsorted data integer, intent(out) :: ina (:) sort index private subroutine sortx_m_r8(dat, ina) (C) Alex Schwarzenberg-Czerny, 2005      alex@camk.edu.pl\n Stable index sorting by merge sort. Requires extra memory (inb) Arguments Type Intent Optional Attributes Name real(kind=8), intent(in) :: dat (:) unsorted data integer, intent(out) :: ina (:) sort index Functions public function dict_val (dict, isize, key) Find key position in a keyword dictionary.\n Restriction: dictionary entries are of equal size,\n all kept in one string. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: dict Dictionary string integer, intent(in) :: isize size of keys character(len=*), intent(in) :: key key string Return Value integer Key position public function tolower (str) Change string case to lower Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: str input string Return Value character(len=Len(str)) result output string public function toupper (str) Change string case to upper Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: str input string Return Value character(len=Len(str)) result output string public function givens (r, idf, detnth) overdetermined linear system by accurate Givens rotations.\n Prior to GIVENS call m-times GIVENSA in order to build the\n triangle system R\n (C) Alex Schwarzenberg-Czerny,2000      alex@camk.edu.pl Arguments Type Intent Optional Attributes Name real(kind=SP), intent(inout) :: r (:,:) r(n1,:)   - unknowns\n (r(k,k),k=1,n) variances\n (r(:k,k),k=1,n) half of covariance matrix\n (r(k+1:,k),k=2,n) half of inverse triangle root Q\n r(n1,n1) - chi&#94;2/idf (=RHS variance=std.dev&#94;2)\n         For idf<0:\n ((r(j,k),j=1,k),k=1,n) inverse triangle root  Q integer, intent(in) :: idf idf - >0 solve normal equations for idf degrees of freedom\n       <0 and r(n1,n1)=1: inverse triangle matrix R real(kind=SP), intent(out) :: detnth =Det(R)&#94;(1/n) - n-th root of determinant Return Value real(kind=SP) result condition ratio (min eigenv/max eigenv),\n 0 signalls singular system Subroutines public subroutine givensacc (a, r) overdetermined linear system by Givens rotations, a state-of-art\n algorithm. Routine takes current observation equation from a and\n accumulates it into r:\n (C) Alex Schwarzenberg-Czerny,2000      alex@camk.edu.pl Arguments Type Intent Optional Attributes Name real(kind=SP), intent(in) :: a (:) a(n1)    - an equation with its RHS as a(n1) element,\n            multiplied by sqrt of weight.\n            Note: sum of all weights must equall no.observations,\n            lest GIVENS returns wrong covariance estimates. real(kind=SP), intent(inout) :: r (:,:)","tags":"","loc":"module/aovsub.html"},{"title":"aovspec – Aov","text":"Routines for handling frequency spectra.\n This file is part of AOV package of routines for computation and evaluation\n of periodograms.\n (C) A. Schwarzenberg-Czerny 1998-2018, alex@camk.edu.pl\n Its distribution is free, except that distribution of modifications is\n prohibited. Uses aovconst mprms aovsub Contents Functions cre_spec fgrid Subroutines clr_spec peak peakrm Functions public function cre_spec (nfr, fr0, frs) create structure for spectrum frequency grid Arguments Type Intent Optional Attributes Name integer, intent(in) :: nfr number of frequencies real(kind=TIME), intent(in) :: fr0 initial frequency real(kind=TIME), intent(in) :: frs frequency step Return Value type(SPEC_T) new spec structure public function fgrid (t, npar, fr0in, fruin, frsin) Robust routine for evaluation of the time sampling pattern\n and guessing a suitable frequency grid. The spec structure containing\n grid parameters is returned as function value. Read more… Arguments Type Intent Optional Attributes Name real(kind=TIME), intent(in) :: t (:) times integer, intent(in) :: npar number of model parameters (to refine frequency grid) real(kind=TIME), intent(in) :: fr0in low frequency real(kind=TIME), intent(in) :: fruin high frequency real(kind=TIME), intent(in) :: frsin if positive set input grid values, though fru>=frs is forced;\n           otherwise they are calculated within routine. Return Value type(SPEC_T) new spec structure\n spec.NFR, spec.FR0 and spec.FRS\n where NFR is calculated as (FRU-FR0)/FRS+1 Subroutines public subroutine clr_spec (spec) clear structure for spectrum frequency grid Arguments Type Intent Optional Attributes Name type(SPEC_T) :: spec spec structure to destroy public subroutine peak (n, fx, xm, fm, dx) Scan periodogram for a peak and return its properties Method: For f=log(fx) fits a parabola 0.5(d2*x**2+d1*x)+f(2) where d2=f(1)+f(3)-2f(2) , d1=f(3)-f(1) finds dxl & dxp such, that the linear and quadratic terms drop\n by 0.7 in log, i.e. by a factor of 2 (dx=HWHI) . (C) Alex Schwarzenberg-Czerny, 1999-2005 alex@camk.edu.pl Arguments Type Intent Optional Attributes Name integer, intent(in) :: n periodogram length real(kind=SP), intent(in) :: fx (n) periodogram values real(kind=TIME), intent(out) :: xm peak location (in index units, 1<xm<n) real(kind=SP), intent(out) :: fm peak value; real(kind=SP), intent(out) :: dx peak halfwidth HWHI,dx<0 no valid peak public subroutine peakrm (dt, spec, freq, thm, dfm) Finds a peak and flags it to search for subsequent ones.\n Flags are negated weights, so they are not lost. Arguments Type Intent Optional Attributes Name real(kind=TIME), intent(in) :: dt peak width type(SPEC_T) :: spec spectrum structure (changed on output) real(kind=TIME), intent(out) :: freq current peak frequency real(kind=SP), intent(out) :: thm current peak value real(kind=SP), intent(out) :: dfm current peak width","tags":"","loc":"module/aovspec.html"},{"title":"mprms – Aov","text":"Module demonstrates reading f90 program global arguments from parameter file\n and/or command line. Implementation: In the present module as global variables declare and set default values\n to all code parameters. To reset them from parameter file and/or command line\n in the Main program call once subroutine prog_args from this module.\n All modules may access these values via Use mparam declaration.\n You may use Only phrase to restrict access/prevent confusion with\n local variables. To make code clearer you may capitalize parameters though\n it has no impact on the compiler so name variables with care. Operation: The initial declared values are overwritten subsequently by those present\n in the parameter file and command line. Syntax rules follow those of f90\n NAMELIST file. Note insensitivity to capitalization and order and\n use of both space and comma as delimiters.\n Parameter lists including strings must be enclosed with\n yet another pair of string marks (see examples). History: Based on an example Namelist use by John S. Urban, 2009 http://www.urbanjost.altervista.org/LIBRARY/libGPF/arguments/namelist/index.html (C) alex schwarzenberg-czerny, 2018, alex@camk.edu.pl Example parameter file prog_args.par: &par OTHER_INTEGER=2 / Example calls: ./t SOME_LOGICAL=T some_real=200e3  OTHER_INTEGER=200 ./t \"SOME_STRING='my character string' SOME_INTEGER=10,SOME_REAL=20.30\" ./t other_INTEGER=33333, SOME_INTEGER=22222 Uses aovconst aovsub Contents Variables VERBOSE ERRIN NBEST CTMIN FSAMPL FR0 FRU FRS MXFRQ NPAR NCOV meths METHOD SPTYPE DIR EXT STAR STRLST EPOCH Functions prog_args Subroutines print_args Variables Type Visibility Attributes Name Initial logical, public :: VERBOSE = .False. Printout control logical, public :: ERRIN = .False. Error column present? integer, public :: NBEST = 5 Number of best frequencies integer, public :: CTMIN = 5 minimum bin occupancy real(kind=SP), public :: FSAMPL = 7._SP oversampling factor real(kind=TIME), public :: FR0 = 0. lower frequency real(kind=TIME), public :: FRU = 4. upper frequency real(kind=TIME), public :: FRS = 0. frequency step (0.-optimum sampling)\n  warning: undersampling risk for FRS>0. integer, public :: MXFRQ = 1000000 max number of frequencies integer, public :: NPAR = 5 number of model parameters integer, public :: NCOV = 2 number of bin coverages character(len=4), public, parameter :: meths (8) = (/'AOV ', 'ATR ', 'AMH ', 'PWS ', 'AOVW', 'ATRW', 'AMHW', 'PWSW'/) character(len=4), public :: METHOD = 'AMH' select from\n AOV,ATR,AMH,PWS,AOVW,ATRW,AMHW,PWSW character(len=5), public :: SPTYPE = 'AOV' select from\n RAW,AOV,MODEL,RESID character(len=LSTRING), public :: DIR = '' LC file name prefix character(len=LSTRING), public :: EXT = '.dat' LC file name extension\n obligatory command parameter (no keyword, order matters) character(len=LSTRING), public :: STAR = 'SIMUL' star name; STAR='SIMUL' supplies for calculation simulated test data character(len=LSTRING), public :: STRLST = '' star list file name;\n If non-empty it replaces STAR as source of star names character(len=LSTRING), public :: EPOCH = 'AVE' epoch type: MIN of times, AVE -average, MED -median or else\n number  given in EPOCH. ... just add more variable declaration here and append them to NAMELIST Functions public function prog_args (pname) Inputs arguments succesively from parameter file and command line\n and resets module NAMELIST global variables, if present in input,\n as an intended side effect. par and NAMELIST variables are external. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: pname name of parameter file Return Value integer status Subroutines public subroutine print_args (logunit) Arguments Type Intent Optional Attributes Name integer, intent(in) :: logunit","tags":"","loc":"module/mprms.html"},{"title":"aovobs – Aov","text":"Routines for pre-processing of observations.\n   This is part of the AOV package of routines for computation and\n   evaluation of AOV periodograms.\n   This package is subject to copyrights by its author,\n   (C) A. Schwarzenberg-Czerny 1998-2018,  alex@camk.edu.pl\n   Its distribution is free, except that distribution of modifications is\n   prohibited. Uses aovconst mprms aovsub Contents Functions get_obs test_obs Subroutines clr_obs Functions public function get_obs (fname) Reads 2 or 3 ascii columns of observations from file fname.\n Returns structure obs storing them. Number of columns is set\n basing on first line containing 2 or 3 float numbers. Lines\n inconsistent with the first one are skipped. Arguments Type Intent Optional Attributes Name character(len=*), intent(in) :: fname Input file name Return Value type(OBS_T) result obs structure public function test_obs (no) Returns simulated light curve for test purposes. Arguments Type Intent Optional Attributes Name integer, intent(in) :: no number of observations to simulate Return Value type(OBS_T) result structure containing observations Subroutines public subroutine clr_obs (obs) clear structure for observations Arguments Type Intent Optional Attributes Name type(OBS_T) :: obs obs structure to destroy","tags":"","loc":"module/aovobs.html"},{"title":"aovconst – Aov","text":"AovConst.f90 : global definitions for Aov.f90 Contents Variables VER SP CP TIME LSTRING PI2 msg io Derived Types SPEC_T OBS_T Variables Type Visibility Attributes Name Initial character(len=*), public, parameter :: VER = '25.04.2020' version integer, public, parameter :: SP = Kind(1e0) type of measurements and errors integer, public, parameter :: CP = Kind((1._SP, 1._SP)) type of complex values integer, public, parameter :: TIME = Kind(1d0) type of time & frequency variables integer, public, parameter :: LSTRING = 40 max input string length real(kind=SP), public, parameter :: PI2 = 6.283185307179586476925286766559005768394_SP character(len=80), public :: msg a string variable of local use integer, public :: io a status variable of local use Derived Types type, public :: SPEC_T Spectrum structure Components Type Visibility Attributes Name Initial integer, public :: nfr number of frequencies real(kind=TIME), public :: fr0 lowest frequency real(kind=TIME), public :: frs frequency increment real(kind=SP), public, Allocatable :: th (:) frequency spectrum/periodogram type, public :: OBS_T Observations structure Components Type Visibility Attributes Name Initial integer, public :: no = 0 number of observations logical, public :: weights = .False. Weights present? real(kind=TIME), public :: epoch = 0._TIME Epoch real(kind=TIME), public :: tmin = 0._TIME Min time real(kind=TIME), public :: tmax = 0._TIME Max time real(kind=TIME), public, Allocatable :: t (:) real(kind=SP), public, Allocatable :: v (:) real(kind=SP), public, Allocatable :: w (:)","tags":"","loc":"module/aovconst.html"},{"title":"main – Aov","text":"Uses aovconst mprms aovper aovsub aovobs aovspec Aov is a tool for period analysis of irregularly sampled time series,\nsuch as stellar and planetary transit light curves. It relies on state-of-art\nstatistically poweful, robust and fast algorithms implemented in\nmy AovPer package, partly based on my original research and\npublications. All routines come in two flavours, with/without weights. References: -------------------------------------------------------------------------- The methods used are based on my 3 papers, listed in the\ncorresponding routine headers: aov-phase binning aov (Schwarzenberg-Czerny, A., 1989, MNRAS 241, 153); aovmh-multi-harmonic aov (Schwarzenberg-Czerny, A., 1996, ApJ(Lett) 460L, 107); aovtr-transit/eclipse aov (Schwarzenberg-Czerny, A. & Beaulieu, J.-Ph.,\n2006, MNRAS 365, 165); These papers and my software are also available from my web page http://www.camk.edu.pl/~alex/ Please cite this papers accordingly in publications using the current package. Input: -------------------------------------------------------------------------- Observations - one ASCII file per star, 2 or 3 columns in order: time,value,error aov.par - file containing default values of program parameters The file aov.par must exist, at least with dummy content &par / .\nAov command line: may reset parameters from aov.par Star name is either in STAR parameter or input from file named in STRLST.\nFile of star observations is named DIR+STAR+EXT, where + marks concatenation. Running ./aov STAR=SIMUL generates sample input (see Usage).\nCompilation: --------------------------------------------------------------------------- AOV is compiled simply by: gfortran -o aov aovconst.f90 aovsub.f90 aovprms.f90 aovobs.f90 aovspec.f90 aovper.f90 aov.f90 For debugging/testing use: gfortran -g -Og -fimplicit-none -Wall -Wline-truncation -Wcharacter-truncation -Wsurprising -Waliasing -Wimplicit-interface -Wunu\nUsage:<br>\n-------------------------------------------------------------------------<br>\nRunning ./aov generates sample input parameter file aov.par and\ndata file SIMUL1.dat . Then command ./aov STAR=SIMUL1 executes them in the\nordinary way as if provided by the user.<br>\nProgram Parameters:\n---------------------------------------------------------------------<br>\nObligatory Parameters (listed either in aov.par or command line): character (20)    :: STAR=\"\"!  star name or ... <br> character (20)    :: STRLST=\"\"! name of file of star names <br>\n<br>\nOptional command parameters of main interest and their default values real(TIME)        :: FR0=0. !  lower frequency real(TIME)        :: FRU=4. !  upper frequency real(TIME)        :: FRS=0. !  frequency step (0.-optimum sampling) !  warning: undersampling risk for FRS>0. integer           :: NPAR=5  ! number of model parameters integer           :: METHOD=AOVMH ! select from ! AOV,AOVTR,AOVMH,AOVW,AOVTRW,AOVMHW ! Those ending 'W' process weights. integer           :: NCOV=2 ! number of bin coverages character*(20)    :: DIR=''     ! Light curve file name prefix character*(20)    :: EXT='.dat' ! Light curve file name extension Full list is in header of mprms module. Input parameter NPAR sets number of phase bins NPAR phase bins or\nNPAR/2 Fourier harmonics.\nI was using 3<=NPAR<=9 and I do not recommend exceeding these limits\nin general period surveys. For transient search use much higher values\nof NPAR, so that transit width ~1/NPAR. In theory, the CPU time\nis proportional to ~NPAR, but as NPAR increases the spectral\nresolution also increases, so it is advisable to decrease\nthe frequency step by 1/NPAR (done automatically by the code),\nwhich causes CPU time scaling like ~NPAR&#94;2. There\nare possible additional CPU savings, but these are not\nworth worrying about at this stage. NPAR=5 worked well\nfor near sinusoidal oscillations. FSAMPL needs to be set =>3. The FSAMPL=4 choice means 4 frequencies covering\na spectral line. This is in my opinion close to optimal as the code fits\nline profile to find peak frequency. If speed is no problem one can use e.g. FSAMPL=7. The fastest are AOV or AOVW , depending on ERRIN , yet they\nsuffer from an artificial noise/residuals due to sharp steps between phase bins. AMH and AMHW employ a smooth Fourier model hence are statistically better, yet\nabout 10 times slower. All four algorithms complexity scales proportional\nto number of observations, frequencies and model parameters. Methods: ------------------------------------------------------------------ The algorithms employ either bins and sub-bins or projection onto\nortogonal polynomials yielding as fast implementation as possible when\nirregular sampling with large gaps make FFT impractical.\nUse of orthogonal functions, either phase binning or\ntrigonometric polynomials results in statistically near optimal\nbehaviour in that cross-talk/correlation between model elements is minimal.\nBecause of that the algorithms remain fairly robust against outliers.\nMore importantly use of orthogonal functions permits\napplication of the classical Fisher AnoVa statistics to\nevaluate frequency spectrum and reliability of any detected periods.\nDepending on SPTYPE the spectrum obeys either\nFisher-Snedecor F or beta probability distributions. Experience: ----------------------------------------------------------------- The original periodogram/frequency spectrum routines were used on\nover 10&#94;5 stars, as part of f95 TATRY package in OGLE and LCVSS\nmass photometry surveys and in EROS c package\nAll Star Searcher, among others used to analyse 318 light curves\nof suspected variable stars in the field M31C. For the Cepheids\nand the eclipsing binaries. Tests against periods set by manual\ninspection of periodograms and light curves were performed\non 25 000 light curves from ASAS South. The comparision involved the most\nsignificant periods only. The periods always\nagreed or were 2om or 3om or om/2 sub-/harmonics of the published frequency om.\nFor Cepheids NPAR=5 worked well. For eclipsing binaries with proximity\neffects (e.g. W UMA) or for sinusoidal variables NPAR=3 was better,\nhowever 2om ambiguities occured. Trials demonstrated that the aov detection criterion\nused in the present code works better than the Laefler-Kinman,\nPDM and Stetson criteria for eclipsing or pulsating variable stars.\nHowever, picking right NPAR for your problem requires some\ntrial runs before decision on the final NPAR. For some applications,\nsuch as transit search it sis recommended to perform several runs,\ne.g. for NPAR=15, 30 and 60, to scan a range of transit widths. History: ------------------------------------------------------------------- 1989 - development of AOV phase binning routines; 1996 - AOVMH Fourier series routines added; 1999-2002 - all AOV routines expanded for use as module in TATRY code; 2003 - porting of AOV routines into C for use in EROS and DIRECT projects.\n This resulted in major upgrade/factor several sppeding of the algorithm AOV by\n introduction of subbins; 2004 - new transient search algorithm fitting top-hat/box function; 2018 - subsstantial revision: main changes were in array declarations and\nnormalization of observations. All fixed lengh arrays are replaced with the\ndynamic ones. In periodogram subroutines observations are now copied into local\narrays when needed. Input observations are left intact. Small inconsistencies\nwere removed and AOV and AOVTR routines were combined into one AOV routine\nperforming both ordinary phase folding and binning or transit search.\nF95 and C packages became compatible to a high degree. Auto documentation using ford .\nPhases are now calculated in a uniform way using: dph=fr*t[i] dph-=floor(dph) Tests on AMD PC and gcc demonstrated that -=floor is faster than fmod . 2020 - improved handling of command line string parameters, introduction of\n optional list of star names. Copyrights: The whole package is subject to copyrights by its author,\n(C) A. Schwarzenberg-Czerny 1089-2020,  alex@camk.edu.pl\nIt is free to use and copy, yet distribution of modiffications or fragments\nis forbidden. It is unsuitable for application carrying risk of damages.\nTo acknowledge its use, pleas cite papers listed in the References section. Contents Variables simul list dfm thm qual ib j metcnt f fb spec obs Variables Type Attributes Name Initial logical :: simul logical :: list real(kind=SP) :: dfm real(kind=SP) :: thm real(kind=SP) :: qual integer :: ib integer :: j integer :: metcnt real(kind=TIME), Allocatable :: f (:) real(kind=TIME), Allocatable :: fb (:) type(SPEC_T) :: spec type(OBS_T) :: obs","tags":"","loc":"program/main.html"}]}